VERSION 5.00
Begin VB.UserControl aicAlphaImage 
   BackStyle       =   0  'Transparent
   CanGetFocus     =   0   'False
   ClientHeight    =   1080
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   1080
   ClipBehavior    =   0  'None
   ClipControls    =   0   'False
   HasDC           =   0   'False
   HitBehavior     =   0  'None
   MaskColor       =   &H80000014&
   PropertyPages   =   "aicAlphaImage.ctx":0000
   ScaleHeight     =   72
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   72
   ToolboxBitmap   =   "aicAlphaImage.ctx":0015
   Windowless      =   -1  'True
End
Attribute VB_Name = "aicAlphaImage"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

' Credits/Acknowledgements
'   Relies almost totally on my c32bppDIB Suite project. Credits included in that project
'       http://www.planetsourcecode.com/vb/scripts/ShowCode.asp?txtCodeId=67466&lngWId=1
'   Paul Caton for his thunking routines.
'       Timer callbacks created using his code
' For most current updates/enhancements visit the following:
'   Visit http://www.planet-source-code.com/vb/scripts/ShowCode.asp?txtCodeId=68262&lngWId=1

' NOTE: ALL CLASSES AND MODULES WITHIN THIS CONTROL MAY HAVE BEEN MODIFIED AND SOME
'       ROUTINES REMOVED. FOR THE COMPLETE UP TO DATE VERSIONS OF THESE CLASSES VISIT:
'       http://www.planetsourcecode.com/vb/scripts/ShowCode.asp?txtCodeId=67466&lngWId=1

' See the Usage.RTF file provided for more information
' Last updated: 7 Oct 2007
'   added ICrossTalk, cCrossComm classes for better usercontrol-usercontrol communication
'   added GDI+ IDE-safe thunk routine in cCrossComm
'   reworked zb_AddressOf to reduce overall memory requirements

' Common Public Events
Public Event Click(ByVal Button As Integer)
Public Event DblClick(ByVal Button As Integer)
Public Event MouseExit()
Public Event MouseEnter()
Public Event MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
Public Event MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
Public Event MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
Public Event KeyDown(KeyCode As Integer, Shift As Integer)
Public Event KeyPress(KeyAscii As Integer)
Public Event KeyUp(KeyCode As Integer, Shift As Integer)
Public Event OLEDragDrop(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, X As Single, Y As Single)
Public Event OLEDragOver(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, X As Single, Y As Single, State As Integer)

' Custom callbacks
Public Event FadeTerminated(ByVal CurrentOpacity As Long)
' ^^ when FadeInOut is called, this event is fired when the fade has completed
'    Note: It is not fired if the fade was terminated by you


' ///////////////////////////////////////////////////////////////////////
'                       Overview of Properties/Methods
' ///////////////////////////////////////////////////////////////////////
' AutoRedraw. Enables an offscreen DC for the usercontrol to help speed up drawing.
'   -- Overlapped and rotated images are prime candidates as are very large images scaled down to small sizes
' AutoSize. Forces control to size to the scaled image
' ClearImage. Erases the image contained in the control
' Enabled. Allows/prevents control from receiving mouse events
' FadeInOut. Timed gradual change from current opacity to user-defined opacity
' GDIplusEnabled. Returns true if the system can use GDI+
' GDIplusInitialized. Returns true if the usercontol started GDI+
' GetImageBytes. For advanced users. Exposes the control's image as a byte array
'   also can return bytes in a format that can be saved to disk. See ImageType also
' GetImageScales. Returns width/height of the image scaled to passed desired width/height
' GrayScale. Offers several grayscale forumlas to render image against
' HitTest. Offers several options to determine what part of image is "clickable"
' ImageType. Returns the format of the image if KeepOriginalFormat is True
' IntensityOffset.  Lightens or darkens image when rendered
' InversedImage. Toggles between normal and inversed pixel colors
' isMouseOver. Returns if mouse is over image. This is dependent upon HitTest and Enabled
' KeepOriginalFormat. When set, control will cache original image bytes when new image is loaded
' LoadImage_FromArray. Loads image from passed byte array
' LoadImage_FromClipboard. Loads image from clipboard image
' LoadImage_FromFile. Loads image from file name (supports unicode)
' LoadImage_FromHandle. Loads image from an image memory handle
' LoadImage_FromOrignalBytes. If KeepOriginalBytes is True, reloads image from those bytes
' LoadImage_FromResource. Loads an image from a resource file
' LoadImage_FromStdPicture. Loads an image from a stdPicture object
' MaskColor. Used for non-transparent images, color to make transparent
' MaskUsed. Toggle for the MaskColor property
' Mirror. Toggle to mirror the image horizontally/vertically or both
' MouseIcon. Option to set a custom mouse cursor when mouse is over the control
' MousePointer. Enables MouseIcon or selects one of many default cursor shapes
' OffsetImage. Nudges the image, & optionally shadow, n pixels in any direction
' OffsetShadow. Nudges a shadow only n pixels in any direction
' OLEDropMode. Enables the control to act as an OLE drop site
' Opacity. Level of opaqueness for the image. 100 is fully opaque, 0 is transparent
' Rotation. Determines angle of rotation (run time only). RotateEnabled must be True for actual rotation
' RotateEnabled. Boolean whether image will rotate or not.
' ScaleMethod. Determines how image is scaled to control.
' SetImageBytes. For advanced users. Sets image bytes from array. See GetImageBytes
' ShadowColor. The color of the shadow if applied
' ShadowDepth. The depth of the shadow's blur effect if applied
' ShadowEnabled. Toggles whether shadow is applied or not
' ShadowOffsetX. Sets the shadow's horizontal offset. Use OffsetShadow during runtime
' ShadowOffsetY. Sets the shadow's vertical offset. Use OffsetShadow during runtime
' ShadowOpacity. Sets the shadows opaqueness. 100 is fully opaque, 0 is transparent
' StretchQuality. Toggles the quality of resizing interpolations used
' ///////////////////////////////////////////////////////////////////////


'-Callback declarations for Paul Caton thunking magic----------------------------------------------
Private z_CbMem   As Long    'Callback allocated memory address
Private Declare Function GetModuleHandleA Lib "kernel32" (ByVal lpModuleName As String) As Long
Private Declare Function GetProcAddress Lib "kernel32" (ByVal hModule As Long, ByVal lpProcName As String) As Long
Private Declare Function IsBadCodePtr Lib "kernel32" (ByVal lpfn As Long) As Long
Private Declare Function VirtualAlloc Lib "kernel32" (ByVal lpAddress As Long, ByVal dwSize As Long, ByVal flAllocationType As Long, ByVal flProtect As Long) As Long
Private Declare Function VirtualFree Lib "kernel32" (ByVal lpAddress As Long, ByVal dwSize As Long, ByVal dwFreeType As Long) As Long
'-------------------------------------------------------------------------------------------------

' Timer and HitTest related APIs
Private Declare Function SetTimer Lib "user32.dll" (ByVal hwnd As Long, ByVal nIDEvent As Long, ByVal uElapse As Long, ByVal lpTimerFunc As Long) As Long
Private Declare Function KillTimer Lib "user32.dll" (ByVal hwnd As Long, ByVal nIDEvent As Long) As Long
Private Declare Function WindowFromPoint Lib "user32.dll" (ByVal xPoint As Long, ByVal yPoint As Long) As Long
Private Declare Function GetCursorPos Lib "user32.dll" (ByRef lpPoint As POINTAPI) As Long
Private Declare Function PtInRegion Lib "gdi32.dll" (ByVal hRgn As Long, ByVal X As Long, ByVal Y As Long) As Long
Private Declare Function PtInRect Lib "user32.dll" (ByRef lpRect As RECT, ByVal X As Long, ByVal Y As Long) As Long
Private Declare Function ClientToScreen Lib "user32.dll" (ByVal hwnd As Long, ByRef lpPoint As POINTAPI) As Long
Private Declare Function GetParent Lib "user32.dll" (ByVal hwnd As Long) As Long

' Drawing related APIs
Private Declare Sub CopyMemory Lib "kernel32.dll" Alias "RtlMoveMemory" (ByRef Destination As Any, ByRef Source As Any, ByVal Length As Long)
Private Declare Function GetSysColor Lib "user32" (ByVal nIndex As Long) As Long
Private Declare Function GetDC Lib "user32.dll" (ByVal hwnd As Long) As Long
Private Declare Function CreateCompatibleBitmap Lib "gdi32.dll" (ByVal hDC As Long, ByVal nWidth As Long, ByVal nHeight As Long) As Long
Private Declare Function CreateCompatibleDC Lib "gdi32.dll" (ByVal hDC As Long) As Long
Private Declare Function DeleteObject Lib "gdi32.dll" (ByVal hObject As Long) As Long
Private Declare Function DeleteDC Lib "gdi32.dll" (ByVal hDC As Long) As Long
Private Declare Function ReleaseDC Lib "user32.dll" (ByVal hwnd As Long, ByVal hDC As Long) As Long
Private Declare Function SelectObject Lib "gdi32.dll" (ByVal hDC As Long, ByVal hObject As Long) As Long
Private Declare Function BitBlt Lib "gdi32.dll" (ByVal hDestDC As Long, ByVal X As Long, ByVal Y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal dwRop As Long) As Long
Private Declare Function GetClipBox Lib "gdi32.dll" (ByVal hDC As Long, ByRef lpRect As RECT) As Long
Private Declare Function GetRgnBox Lib "gdi32.dll" (ByVal hRgn As Long, ByRef lpRect As RECT) As Long
Private Declare Function SetRect Lib "user32.dll" (ByRef lpRect As RECT, ByVal X1 As Long, ByVal Y1 As Long, ByVal X2 As Long, ByVal Y2 As Long) As Long
Private Declare Function IntersectRect Lib "user32.dll" (ByRef lpDestRect As RECT, ByRef lpSrc1Rect As RECT, ByRef lpSrc2Rect As RECT) As Long
Private Declare Function OffsetRect Lib "user32.dll" (ByRef lpRect As RECT, ByVal X As Long, ByVal Y As Long) As Long
Private Declare Function OffsetRgn Lib "gdi32.dll" (ByVal hRgn As Long, ByVal X As Long, ByVal Y As Long) As Long

Private Type RECT
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
End Type
Private Type POINTAPI
    X As Long
    Y As Long
End Type
Private Type MASKUSAGE
    Color As Long           ' current mask color
    Applied As Boolean      ' mask has been applied
    AppliedColor As Long    ' color used to create mask; may not be same as Color
    Source As aiMaskSource  ' mask option: see aiMaskSource enum
End Type
Private Type FADERCONTROL
    tmrAddr As Long         ' AddressOf timer call back procedure
    fStep As Long           ' percent of opacity to change between steps
    fDelay As Long          ' length to delay before next step occurs
    fOpacity As Long        ' final opacity that also terminates the fader
End Type
Private Type SCALEDCOORD
    Left As Long            ' position of image within usercontrol
    Top As Long
    Width As Long           ' size of image within usercontrol
    Height As Long
    RotatedSize As Long     ' when rotated, the size needed to completely rotate image 360 degrees
    xOffset As Long         ' runtime offsets to render image....
    yOffset As Long         '   could be used to shift image when user clicks on it to create a down effect
    OneToOne As Boolean     ' flag used for painting; when image is actual size, faster renders
End Type

Public Enum aiMaskSource
    aiNoMask = 0
    aiUseMaskColor = 1
    aiUseTopLeft = 2
    aiUseTopRight = 3
    aiUseBottomLeft = 4
    aiUseBottomRight = 5
End Enum
Public Enum aiMirrorEnum
    aiMirrorNone = 0
    aiMirrorHorizontal = 1
    aiMirrorVertical = 2
    aiMirrorAll = 3
End Enum
Public Enum aiScaleMethod
    aiScaled = 0
    aiStretch = 1
    aiScaleDownOnly = 2
    aiActualSize = 3
    aiLockScale = 4
End Enum
Public Enum aiGrayScales
    aiNTSCPAL = 1     ' R=R*.299, G=G*.587, B=B*.114 - Default
    aiCCIR709 = 2     ' R=R*.213, G=G*.715, B=B*.072
    aiSimpleAvg = 3   ' R,G, and B = (R+G+B)/3
    aiRedMask = 4     ' uses only the Red sample value: RGB = Red / 3
    aiGreenMask = 5   ' uses only the Green sample value: RGB = Green / 3
    aiBlueMask = 6    ' uses only the Blue sample value: RGB = Blue / 3
    aiRedGreenMask = 7 ' uses Red & Green sample value: RGB = (Red+Green) / 2
    aiBlueGreenMask = 8 ' uses Blue & Green sample value: RGB = (Blue+Green) / 2
    aiNoGrayScale = 0
End Enum
Public Enum aiHitTestStyle  ' see HitTest property
    aiBoundingRgn = 1
    aiEnclosedRgn = 2
    aiShapedRgn = 3
    aiEntireControl = 0
End Enum
Public Enum aiOLEDropMode
    aiDropNone = vbOLEDropNone
    aiDropManual = vbOLEDropManual
End Enum
Public Enum eImageFormatUC    ' source image format
    img_Error = -1  ' no DIB has been initialized
    img_None = 0    ' no image loaded
    img_Bitmap = 1  ' standard bitmap or jpg
    img_Icon = 3    ' standard icon
    img_WMF = 2     ' windows meta file
    img_EMF = 4     ' enhanced WMF
    img_Cursor = 5  ' standard cursor
    img_BmpARGB = 6  ' 32bpp bitmap where RGB is not pre-multiplied
    img_BmpPARGB = 7 ' 32bpp bitmap where RGB is pre-multiplied
    img_IconARGB = 8 ' XP-type icon; 32bpp ARGB
    img_GIF = 9      ' gif; if class.Alpha=True, then transparent GIF
    img_PNG = 10     ' PNG image
    img_PNGicon = 11 ' PNG in icon file (Vista)
    img_CursorARGB = 12 ' alpha blended cursors? do they exist yet?
    img_CheckerBoard = 64 ' image is displaying own checkerboard pattern; no true image
End Enum

Private Enum eProps
    pHiQualty = 1       'HighQuality interpolation
    pAutoStretch = 2    'Auto Stretch
    pAutoSize = 4       'Auto Size
    pAutoRedraw = 8     'Auto Redraw
    pKeepBytes = 16     'Cache original bytes
    pOffscreen = 32     'Offscreen image maintained
    pMasked = 64        'Image is masked for transparency
    pShadowed = 128     'Image has shadow class
    pRotated = 256      'Image can be rotated
End Enum
Private cKeyProps As eProps
Private cBtnClickTracker As Integer    ' tracks button used to trigger click/dblclick events


Private cAngle As Long
Private cHitTest As aiHitTestStyle
Private cRegion As Long     ' used when cHitTest is aiShapedRgn, aiEnclosedRgn
Private cRgnBox As RECT     ' used when cHitTest is aiEntireControl, aiBoundingRgn

Private cGrayScale As aiGrayScales
Private cScaleMode As ScaleModeConstants    ' parent container's scalemode; used for public events
Private cScaleMethod As aiScaleMethod
Private cMirror As aiMirrorEnum
Private cOpacity As Long
Private cIntesity As Single
Private cMask As MASKUSAGE
Private cScaledCoords As SCALEDCOORD

Private cImage As c32bppDIB
Private cOffscreen As c32bppDIB             ' used when AutoRedraw=True

'//Timer & mouse enter/exit related variables
Private cTmrAddrOf As Long
Private cTmrHwnd As Long
Private cTopLeftPos As POINTAPI
Private cFader As FADERCONTROL

'//Shadow options
Private cShadowClass As c32bppDIB           ' used when creating shadows on non-actual size images
Private cShadowColor As Long
Private cShadowOffset As POINTAPI
Private cShadowDepth As Long
Private cShadowOpacity As Long

Private cCrossTalker As cCrossComm
Implements ICrossComm


' This module is grouped/organized into the following sections:
'   Public Properties & Functions
'   Property Page Routines
'   Inter-Control Communication
'   Support/Helper Routines
'   Usercontrol Properties
'   Callback Thunking Routines
'=========================================================================================================
' /////////////////////// P U B L I C   P R O P E R T I E S  &  F U N C T I O N S \\\\\\\\\\\\\\\\\\\\\\\\
'=========================================================================================================

Public Sub ClearImage()
    ' Purpose: Permanently remove the control's image source
    If ((cKeyProps And pOffscreen) = pOffscreen) Then Set cOffscreen = Nothing
    cImage.DestroyDIB
    Set cShadowClass = Nothing
    If Ambient.UserMode = True Then
        UserControl.Refresh
    Else ' can be called by the property page during design time
        cImage.InitializeDIB cScaledCoords.Width, cScaledCoords.Height
        cImage.CreateCheckerBoard
        sptResize
    End If
End Sub

Public Sub Refresh()
    On Error Resume Next
    ' attempt to get actual scalemode. Errors occur when container has no scalemode (i.e.,frame)
    cScaleMode = UserControl.Parent.ScaleMode
    If Err Then
        Err.Clear
        cScaleMode = vbContainerPosition
        '^^ the above can be used for any scalemode; however, when container scalemode is
        ' vbTwips or vbPixels, the returned X,Y coordinates passed back are decimal not integer
    End If
    On Error GoTo 0
    ' Purpose: Simply refresh the control
    UserControl.Refresh
   
End Sub

Public Function LoadImage_FromArray(inStream() As Byte, Optional desiredIconWidth As Long, Optional desiredIconHeight As Long, Optional desiredIconBitDepth As Long) As Boolean
    ' Purpose. Load an image from array
    If desiredIconHeight < 1 Then desiredIconHeight = UserControl.ScaleHeight
    If desiredIconWidth < 1 Then desiredIconWidth = UserControl.ScaleWidth
    If desiredIconBitDepth < 1 Then desiredIconBitDepth = 32&
    If cImage.LoadPicture_Stream(inStream, desiredIconWidth, desiredIconHeight, , , ((cKeyProps And pKeepBytes) = pKeepBytes), desiredIconBitDepth) Then
        sptReplaceImage
        LoadImage_FromArray = True
    End If
End Function
Public Function LoadImage_FromFile(FileName As String, Optional desiredIconWidth As Long, Optional desiredIconHeight As Long, Optional desiredIconBitDepth As Long) As Boolean
    ' Purpose. Load an image from a file
    If desiredIconHeight < 1 Then desiredIconHeight = UserControl.ScaleHeight
    If desiredIconWidth < 1 Then desiredIconWidth = UserControl.ScaleWidth
    If desiredIconBitDepth < 1 Then desiredIconBitDepth = 32&
    If cImage.LoadPicture_File(FileName, desiredIconWidth, desiredIconHeight, ((cKeyProps And pKeepBytes) = pKeepBytes), desiredIconBitDepth) Then
        sptReplaceImage
        LoadImage_FromFile = True
    End If
End Function
Public Function LoadImage_FromStdPicture(stdPic As StdPicture) As Boolean
    ' Purpose. Load an image from stdPicture object
    If cImage.LoadPicture_StdPicture(stdPic) = True Then
        If ((cKeyProps And pKeepBytes) = pKeepBytes) Then
            Dim srcData() As Byte
            cImage.SaveToStream srcData
            cImage.SetOriginalFormat srcData
        End If
        sptReplaceImage
        LoadImage_FromStdPicture = True
    End If
End Function
Public Function LoadImage_FromClipboard() As Boolean
    ' Purpose. Load an image from the clipboard
    If cImage.LoadPicture_ClipBoard() Then
        If ((cKeyProps And pKeepBytes) = pKeepBytes) Then
            Dim srcData() As Byte
            cImage.SaveToStream srcData
            cImage.SetOriginalFormat srcData
            Erase srcData()
        End If
        sptReplaceImage
        LoadImage_FromClipboard = True
    End If
End Function
Public Function LoadImage_FromHandle(Handle As Long) As Boolean
    ' Purpose. Load an image from an image handle
    If cImage.LoadPicture_ByHandle(Handle) Then
        If ((cKeyProps And pKeepBytes) = pKeepBytes) Then
            Dim srcData() As Byte
            cImage.SaveToStream srcData
            cImage.SetOriginalFormat srcData
        End If
        sptReplaceImage
        LoadImage_FromHandle = True
    End If
End Function
Public Function LoadImage_FromResource(VBglobal As IUnknown, ResSection As Variant, ResID As Variant, Optional desiredIconWidth As Long, Optional desiredIconHeight As Long, Optional desiredIconBitDepth As Long) As Boolean
    ' Purpose. Load an image from a resource file
    
    ' Pass VBglobal like so:  VB.Global
    ' Pass ResSection as: vbResBitmap, vbResIcon, "Custom", etc
    ' Pass ResID as:  101, "MyLogo", etc
    If desiredIconHeight < 1 Then desiredIconHeight = UserControl.ScaleHeight
    If desiredIconWidth < 1 Then desiredIconWidth = UserControl.ScaleWidth
    If desiredIconBitDepth < 1 Then desiredIconBitDepth = 32&
    If cImage.LoadPicture_Resource(ResID, ResSection, VBglobal, desiredIconWidth, desiredIconHeight, , , desiredIconBitDepth) Then
        sptReplaceImage
        LoadImage_FromResource = True
    End If
End Function
Public Function LoadImage_FromOrignalBytes(Optional desiredIconWidth As Long, Optional desiredIconHeight As Long, Optional desiredIconBitDepth As Long) As Boolean
    ' Purpose. Load an image from a file
    If desiredIconHeight < 1 Then desiredIconHeight = UserControl.ScaleHeight
    If desiredIconWidth < 1 Then desiredIconWidth = UserControl.ScaleWidth
    If desiredIconBitDepth < 1 Then desiredIconBitDepth = 32&
    If cImage.LoadPicture_FromOrignalFormat(desiredIconWidth, desiredIconHeight, desiredIconBitDepth) Then
        sptReplaceImage
        LoadImage_FromOrignalBytes = True
    End If
End Function

Public Function GetImageBytes(imgBytes() As Byte, ByRef scanWidth As Long, _
                                Optional ByVal asArray2D As Boolean = False, _
                                Optional ByVal asBGRformat As Boolean = True, _
                                Optional ByVal asBottomUp As Boolean = False, _
                                Optional ByVal asPreMultiplied As Boolean = False, _
                                Optional ByVal asFileFormat As Boolean = False) As Boolean
    
    ' Purpose: Return the DIB bytes in a 1 or 2 dimensional array
    ' Return value is false if no image exists
    
    ' [Parameters].
    ' imgBytes(): a dynamic byte array; will be redimensioned as needed
    ' scanWidth: placeholder for the scan width of the bytes returned
    ' asArray2D: if True, arrays is returned as (x,y) else array is 1 dimensional
    '   see asFileFormat for an exception
    ' asBGRformat: if True, bytes are BGRA else bytes are RGBA
    ' asBottomUp: if True, first byte is bottom,left of image else is top,left of image
    ' asPremultiplied: if True, bytes are in premultiplied format else they are not
    ' asFileFormat: if True, the array is zero-bound and one dimensional only
    '   no other parameters are used. The array can be saved to disk as a file
    '   Call ImageType property first to determine what image format the bytes
    '   will be returned as
    
    If Not (cImage.ImageType = imgError Or cImage.ImageType = imgNone) Then
    
        If Not cImage.ImageType = imgCheckerBoard Then
            If asFileFormat = True Then
                If cImage.GetOrginalFormat(imgBytes) = False Then
                    If cImage.isGDIplusEnabled Or cImage.isZlibEnabled Then
                        GetImageBytes = cImage.SaveToStream_PNG(imgBytes)
                    Else
                        GetImageBytes = cImage.SaveToStream(imgBytes)
                    End If
                End If
            Else
                scanWidth = cImage.scanWidth
                GetImageBytes = cImage.GetDIBbits(imgBytes, asArray2D, asBGRformat, True, True, asBottomUp, , , , , asPreMultiplied)
            End If
        End If
        
    End If
End Function
Public Function SetImageBytes(imgBytes() As Byte, _
                                Optional ByVal isBGRformat As Boolean = True, _
                                Optional ByVal isBottomUp As Boolean = False) As Boolean
    
    ' Purpose: Sets the DIB bytes with the passed modified bytes and refresh image
    ' Return value is True if the bytes were applied
    
    ' [Parameters].
    ' imgBytes(): a dynamic byte array; must be 1 or 2 dimensional
    ' isBGRformat: if True, bytes are BGRA else bytes are RGBA
    ' isBottomUp: if True, first byte is bottom,left of image else is top,left of image
    
    If Not (cImage.ImageType = imgError) Then
        If cImage.SetDIBbits(imgBytes, isBGRformat, , , isBottomUp) = True Then
            If sptUpdateOffscreen(False, True) = False Then sptRefreshRegion
            If Me.ShadowEnabled Then sptRefreshShadow
            UserControl.Refresh
            SetImageBytes = True
        End If
    End If
End Function

Public Sub GetImageScales(ByRef Width As Long, ByRef Height As Long, _
            Optional ByVal ScaleMethod As aiScaleMethod = -1, _
            Optional ByVal desiredWidth As Long, Optional ByVal desiredHeight As Long, _
            Optional ByVal asRotatedImage As Boolean = False)
            
    ' Purpose: Return the size of the image that will fit within the passed
    '       DC dimensions using the passed scale method
    ' Notes:
    '   1. Parameters are pixels
    '   2. To resize your control to allow full rotation, use Sqr(Width*Width+Height*Height)
    
    ' [Parameters]
    '   Width. Variable to hold the returned scaled width
    '   Height. Variable to hold the returned scaled height
    '   ScaleMethod. If -1 then the current scale method will be used else the passed method
    '   desiredWidth. The desired width. If not passed, the current usercontrol width is used
    '   desiredHeight.  The desired height. If not passed, the current usercontrol height is used
    '   asRotatedImage. Indicates the desired width/height allows full 360 degree rotation
    
    If cImage.Handle = 0& Then Exit Sub
            
    If ScaleMethod < aiScaled Then
        ScaleMethod = cScaleMethod
    ElseIf ScaleMethod > aiLockScale Then
        ScaleMethod = aiLockScale
    End If
    
    If ScaleMethod = aiLockScale Then
        Width = cScaledCoords.Width
        Height = cScaledCoords.Height
        Exit Sub
    End If
    
    If desiredWidth < 1 Then desiredWidth = UserControl.ScaleWidth
    If desiredHeight < 1 Then desiredHeight = UserControl.ScaleHeight
    
    Dim xRatio As Single, yRatio As Single
    Dim rotSize As Long
    
    If asRotatedImage Then
        If ScaleMethod = aiActualSize Then
            Width = cImage.Width
            Height = cImage.Height
        Else
            rotSize = Sqr(cImage.Width * cImage.Width + cImage.Height * cImage.Height)
            xRatio = cImage.Width / rotSize
            yRatio = cImage.Height / rotSize
            Select Case ScaleMethod
            Case aiStretch
                Width = desiredWidth * xRatio
                Height = desiredHeight * yRatio
            Case Else
                If desiredWidth > desiredHeight Then
                    rotSize = desiredHeight
                Else
                    rotSize = desiredWidth
                End If
                Width = rotSize * xRatio
                Height = rotSize * yRatio
                If ScaleMethod = aiScaleDownOnly Then
                    If Width > cImage.Width Or Height > cImage.Height Then
                        Width = cImage.Width
                        Height = cImage.Height
                    End If
                End If
            End Select
        End If
    Else
        Select Case ScaleMethod
        Case aiActualSize
            Width = cImage.Width
            Height = cImage.Height
        Case aiStretch
            Width = desiredWidth
            Height = desiredHeight
        Case Else
            xRatio = desiredWidth / cImage.Width
            yRatio = desiredHeight / cImage.Height
            If yRatio < xRatio Then xRatio = yRatio
            If ScaleMethod = aiScaleDownOnly Then
                If xRatio > 1 Then xRatio = 1
            End If
            Width = cImage.Width * xRatio
            Height = cImage.Height * xRatio
        End Select
    End If
    
End Sub
            
Public Property Get ImageType() As eImageFormatUC
    ' Useful if you want to call GetImageBytes to return the image in file format for saving.
    ' Call this property first to determine the format to be returned by GetImageBytes
    If cImage.ImageType = imgError Or cImage.ImageType = imgNone Or cImage.ImageType = imgCheckerBoard Then
        ImageType = imgNone
    ElseIf (cKeyProps And pKeepBytes) = pKeepBytes Then ' original format kept
        ImageType = cImage.ImageType
    ElseIf cImage.isGDIplusEnabled = True Then
        ImageType = imgPNG
    ElseIf cImage.isZlibEnabled = True Then
        ImageType = imgPNG
    ElseIf cImage.Alpha = True Then
        ImageType = imgBmpPARGB
    Else
        ImageType = imgBitmap
    End If
End Property
Public Sub FadeInOut(ByVal FinalOpacity As Long, Optional ByVal FadeStepPercent As Long = 10, Optional ByVal FadeDelayInterval As Long = 30)
    
    ' Purpose: Fade an image from one opacity to another at a stepped percentage while delaying n milliseconds between steps
    ' Note: all values should be positive numbers. Routines will double check and adjust as needed
    
    ' [Parameters]
    ' FinalOpacity: The opacity of the image when the fader terminates
    ' FadeStepPercent: What percentage of opaqueness image should change between intervals (valid values are 1 to 100)
    ' FadeDelayInterval: How long image should remain before next fade step occurs (valid values are 10 to max long value)
    
    ' Kill current fader if it exists
    If Not cFader.fStep = 0& Then
        KillTimer cTmrHwnd, -ObjPtr(Me)
        cFader.fStep = 0&
    End If
    
    ' validate final opacity parameters
    If FinalOpacity < 0& Then
        FinalOpacity = 0&
    ElseIf FinalOpacity > 100& Then
        FinalOpacity = 100&
    End If
    ' validate step value
    If FadeStepPercent = 0& Then
        Exit Sub
    Else
        ' set up fader control
        If Not cOpacity = FinalOpacity Then
            If FinalOpacity < cOpacity Then
                FadeStepPercent = -Abs(FadeStepPercent) ' must be negative
            Else
                FadeStepPercent = Abs(FadeStepPercent)  ' else must be positive
            End If
            With cFader
                ' get AddressOf for our fader timer
                If .tmrAddr = 0& Then .tmrAddr = zb_AddressOf(2, 4, 1)
                .fOpacity = FinalOpacity        ' set final opacity value
                .fStep = FadeStepPercent        ' set fader step value
                If FadeDelayInterval < 10 Then  ' set fader interval
                    .fDelay = 10
                Else
                    .fDelay = FadeDelayInterval
                End If
            End With
            ' fire first fader event
            Call Timer_Fader(cTmrHwnd, 0&, -ObjPtr(Me), 0&)
        End If
    End If
    
End Sub

Public Property Let AutoRedraw(Enable As Boolean)
    ' Purpose: create/maintain a scaled/drawn image in its own DC.
    ' Although it uses more resources, images are rendered much faster since they
    ' to not have to be resized, rotated, mirrored, etc, each time the control must be updated
    ' Additionally, since the cached image is now at a 1:1 ratio, rendering only occurs to
    ' the invalidated portion of the control, not the entire control each time
    If Not (((cKeyProps And pAutoRedraw) = pAutoRedraw) = Enable) Then
        cKeyProps = cKeyProps Xor pAutoRedraw
        If Ambient.UserMode = True Then
            cKeyProps = cKeyProps Xor pOffscreen
            If Enable = False Then Set cOffscreen = Nothing
        End If
        PropertyChanged "AutoRedraw"
    End If
End Property
Public Property Get AutoRedraw() As Boolean
    AutoRedraw = ((cKeyProps And pAutoRedraw) = pAutoRedraw)
End Property

Public Property Let HitTest(Style As aiHitTestStyle)
    ' Determines whether the mouse in the control registers as within the image
    ' Possible values are:
    ' - aiEntireControl. Mouse anywhere within the control is allowed
    ' - aiShapedRgn. Mouse on any non-transparent pixel is allowed
    ' - aiBoundingRgn. Mouse within the tightest rectangle around image is valid
    ' - aiEnclosedRgn. Same as aiShapedRgn but any transparent pixels that fall
    '       between non-transparent pixels is considered non-transparent
    If Style >= aiEntireControl And Style <= aiShapedRgn Then
        If Not Style = cHitTest Then
            cHitTest = Style
            sptRefreshRegion
            PropertyChanged "HitTest"
        End If
    End If
End Property
Public Property Get HitTest() As aiHitTestStyle
    HitTest = cHitTest
End Property

Public Property Let MaskColor(Color As OLE_COLOR)
    ' Allows making a color within a non-transparent bitmap transparent
    If cMask.Applied Then ' previous mask already applied, remove it
        If cMask.Source = aiUseMaskColor Then
            sptUndoMask
            If (cKeyProps And pMasked) = pMasked Then
                cImage.MakeTransparent sptConvertSysColor(Color) Xor vbWhite
            Else
                cImage.MakeTransparent sptConvertSysColor(Color)
            End If
            cMask.AppliedColor = Color
            If sptUpdateOffscreen(False, True) = False Then sptRefreshRegion
            If Me.ShadowEnabled Then sptRefreshShadow
            UserControl.Refresh
        End If
    End If
    cMask.Color = Color
    PropertyChanged "MaskColor"
End Property
Public Property Get MaskColor() As OLE_COLOR
    MaskColor = cMask.Color
End Property

Public Property Let MaskUsed(Style As aiMaskSource)
    ' Enables the mask to take effect.
    ' Only applies to non-transparent images
    If cMask.Applied = False And cImage.Alpha = True Then Exit Property
    If Style >= aiNoMask And Style <= aiUseBottomRight Then
        If Not cMask.Source = Style Then
            If Not cImage.ImageType = imgCheckerBoard Then
                Dim mColor As Long
                If cMask.Applied Then sptUndoMask
                If Style = aiNoMask Then
                    cMask.Applied = False
                Else
                    Select Case Style
                    Case aiUseMaskColor
                        cMask.AppliedColor = cMask.Color
                    Case aiUseBottomLeft
                        cMask.AppliedColor = cImage.GetPixel(0, cImage.Height - 1, , False)
                    Case aiUseBottomRight
                        cMask.AppliedColor = cImage.GetPixel(cImage.Width - 1, cImage.Height - 1, , False)
                    Case aiUseTopLeft
                        cMask.AppliedColor = cImage.GetPixel(0, 0, , False)
                    Case aiUseTopRight
                        cMask.AppliedColor = cImage.GetPixel(cImage.Width - 1, 0, , False)
                    End Select
                    cMask.Applied = True
                    If (cKeyProps And pMasked) = pMasked Then
                        If Style = aiUseMaskColor Then
                            mColor = sptConvertSysColor(cMask.AppliedColor) Xor vbWhite
                        Else
                            mColor = cMask.AppliedColor
                            cMask.AppliedColor = mColor Xor vbWhite
                        End If
                    Else
                        mColor = sptConvertSysColor(cMask.AppliedColor)
                    End If
                    cImage.MakeTransparent mColor
                End If
                If sptUpdateOffscreen(False, True) = False Then sptRefreshRegion
                If Me.ShadowEnabled Then sptRefreshShadow
                UserControl.Refresh
                cMask.Source = Style
                PropertyChanged "MaskUsed"
            End If
        End If
    End If
End Property
Public Property Get MaskUsed() As aiMaskSource
    MaskUsed = cMask.Source
End Property

Public Property Let InversedImage(Inverse As Boolean)
    ' Purpose: Inverts the colors of an image. Can be toggled
    If Not (((cKeyProps And pMasked) = pMasked) = Inverse) Then
        cKeyProps = cKeyProps Xor pMasked
        cImage.MakeImageInverse
        PropertyChanged "InversedImage"
        sptUpdateOffscreen False, False
        UserControl.Refresh
    End If
End Property
Public Property Get InversedImage() As Boolean
    InversedImage = ((cKeyProps And pMasked) = pMasked)
End Property

Public Property Let AutoSize(Value As Boolean)
    ' Purpose: Forces control to resize to the scaled image size
    If Not (((cKeyProps And pAutoSize) = pAutoSize) = Value) Then
        cKeyProps = cKeyProps Xor pAutoSize
        sptResize
        PropertyChanged "AutoSize"
    End If
End Property
Public Property Get AutoSize() As Boolean
    AutoSize = ((cKeyProps And pAutoSize) = pAutoSize)
End Property

Public Property Let ScaleMethod(Method As aiScaleMethod)
    ' Purpose: Determine whether image is scaled proportionally or not
    If Not Method = cScaleMethod Then
        cScaleMethod = Method
        Call sptResize
        PropertyChanged "Stretch"
    End If
End Property
Public Property Get ScaleMethod() As aiScaleMethod
    ScaleMethod = cScaleMethod
End Property

Public Property Let StretchQuality(highQuality As Boolean)
    ' Determines algoritm to use when stretching an image
    If Not (((cKeyProps And pHiQualty) = pHiQualty) = highQuality) Then
        cKeyProps = cKeyProps Xor pHiQualty
        cImage.HighQualityInterpolation = highQuality
        UserControl.Refresh
        PropertyChanged "StretchQuality"
    End If
End Property
Public Property Get StretchQuality() As Boolean
    StretchQuality = ((cKeyProps And pHiQualty) = pHiQualty)
End Property

Public Property Let Opacity(ByVal Opaqueness As Long)
    ' Purpose: Set how opaque the image will be rendered at; 100=fully opaque, 0=fully transparent
    If Not Opaqueness = 0 Then
        Opaqueness = Abs(Opaqueness) Mod 100
        If Opaqueness = 0 Then Opaqueness = 100
    End If
    cOpacity = Opaqueness
    PropertyChanged "Opacity"
    UserControl.Refresh
End Property
Public Property Get Opacity() As Long
    Opacity = cOpacity
End Property

Public Property Let Mirror(MirrorType As aiMirrorEnum)
    ' Purpose. Mirror an image horizontally or vertically or both
    If MirrorType >= aiMirrorNone And MirrorType <= aiMirrorAll Then
        sptMirrorImage MirrorType
        cMirror = MirrorType
        If sptUpdateOffscreen(False, True) = False Then sptRefreshRegion
        If Me.ShadowEnabled Then sptRefreshShadow
        UserControl.Refresh
        PropertyChanged "Mirror"
    End If
End Property
Public Property Get Mirror() As aiMirrorEnum
    Mirror = cMirror
End Property

Public Property Let KeepOriginalFormat(Keep As Boolean)
    ' Forces routines to keep a copy of the image in its original format
    ' This will be used more in upcoming versions
    If Not (((cKeyProps And pKeepBytes) = pKeepBytes) = Keep) Then
        cKeyProps = cKeyProps Xor pKeepBytes
        PropertyChanged "KeepOriginalFormat"
    End If
End Property
Public Property Get KeepOriginalFormat() As Boolean
    KeepOriginalFormat = ((cKeyProps And pKeepBytes) = pKeepBytes)
End Property

Public Property Let grayScale(Style As aiGrayScales)
    ' Option to toggle grayscale effect
    ' Note: offsetting -1/+1 to align values with the c32bppDIB enumeration
    ' That enumeration does not have a "No Grayscale" option
    If Style >= aiNoGrayScale And Style <= aiBlueGreenMask Then
        If Not cGrayScale = Style - 1 Then
            cGrayScale = Style - 1
            UserControl.Refresh
            PropertyChanged "GrayScale"
        End If
    End If
End Property
Public Property Get grayScale() As aiGrayScales
    grayScale = cGrayScale + 1
End Property

Public Property Let RotateEnabled(canRotate As Boolean)
    If Not (((cKeyProps And pRotated) = pRotated) = Abs(canRotate)) Then
        cKeyProps = cKeyProps Xor pRotated
        sptResize
        PropertyChanged "RotateEnabled"
    End If
End Property
Public Property Get RotateEnabled() As Boolean
    RotateEnabled = ((cKeyProps And pRotated) = pRotated)
End Property

Public Property Let Rotation(ByVal newAngle As Long)
    ' Purpose: Rotate an image by set a degree (-360 to 360)
    newAngle = newAngle Mod 360
    If Not cAngle = newAngle Then
        cAngle = newAngle
        If (cKeyProps And pRotated) = pRotated Then
            If sptUpdateOffscreen(False, True) = False Then sptRefreshRegion
            If Me.ShadowEnabled Then sptRefreshShadow
            UserControl.Refresh
            PropertyChanged "Rotation"
        End If
    End If
End Property
Public Property Get Rotation() As Long
    Rotation = cAngle
End Property

Public Property Let Enabled(Enable As Boolean)
    ' Purpose: Enable/Disable mouse events
    If Not UserControl.Enabled = Enable Then
        UserControl.Enabled = Enable
        If Ambient.UserMode = True Then
            If Enable = True Then
                cCrossTalker.AddRef ObjPtr(Me)
            Else
                If UserControl.Tag = "Timer" Then
                    KillTimer cTmrHwnd, ObjPtr(Me)
                    UserControl.Tag = vbNullString
                End If
                cCrossTalker.RemoveRef ObjPtr(Me)
            End If
            sptRefreshRegion
        End If
        PropertyChanged "Enabled"
    End If
End Property
Public Property Get Enabled() As Boolean
    Enabled = UserControl.Enabled
End Property

Public Property Let ShadowEnabled(Enable As Boolean)
    If Not (((cKeyProps And pShadowed) = pShadowed) = Enable) Then
        cKeyProps = cKeyProps Xor pShadowed
        sptRefreshShadow
        PropertyChanged "ShadowEnabled"
        UserControl.Refresh
    End If
End Property
Public Property Get ShadowEnabled() As Boolean
    ShadowEnabled = Abs((cKeyProps And pShadowed) = pShadowed)
End Property

Public Property Let ShadowColor(Color As OLE_COLOR)
    If Not ShadowColor = Color Then
        cShadowColor = Color
        sptRefreshShadow
        PropertyChanged "ShadowColor"
        UserControl.Refresh
    End If
End Property
Public Property Get ShadowColor() As OLE_COLOR
    ShadowColor = cShadowColor
End Property

Public Property Let ShadowOffsetX(Offset As Long)
    If Not cShadowOffset.X = Offset Then
        cShadowOffset.X = Offset
        If Me.ShadowEnabled Then UserControl.Refresh
        PropertyChanged "ShadowOffsetX"
    End If
End Property
Public Property Get ShadowOffsetX() As Long
    ShadowOffsetX = cShadowOffset.X
End Property
Public Property Let ShadowOffsetY(Offset As Long)
    If Not cShadowOffset.Y = Offset Then
        cShadowOffset.Y = Offset
        If Me.ShadowEnabled Then UserControl.Refresh
        PropertyChanged "ShadowOffsetY"
    End If
End Property
Public Property Get ShadowOffsetY() As Long
    ShadowOffsetY = cShadowOffset.Y
End Property

Public Property Let ShadowDepth(Depth As Long)
    If Not cShadowDepth = Depth Then
        If Depth > -1 And Depth < 11 Then
            cShadowDepth = Depth
            sptRefreshShadow
            PropertyChanged "ShadowDepth"
            UserControl.Refresh
        End If
    End If
End Property
Public Property Get ShadowDepth() As Long
    ShadowDepth = cShadowDepth
End Property

Public Property Let ShadowOpacity(Opaqueness As Long)
    If Not cShadowOpacity = Opaqueness Then
        If Opaqueness > -1 And Opaqueness < 101 Then
            cShadowOpacity = Opaqueness
            If Me.ShadowEnabled Then UserControl.Refresh
            PropertyChanged "ShadowOpacity"
        End If
    End If
End Property
Public Property Get ShadowOpacity() As Long
    ShadowOpacity = cShadowOpacity
End Property
    
Public Property Let MousePointer(Pointer As MousePointerConstants)
    ' same as VB's MousePointer property
    On Error Resume Next
    UserControl.MousePointer = Pointer
    If Err Then Err.Clear
    PropertyChanged "MousePointer"
End Property
Public Property Get MousePointer() As MousePointerConstants
    MousePointer = UserControl.MousePointer
End Property

Public Property Let MouseIcon(Icon As StdPicture)
    ' same as VB's MouseIcon property
    Set Me.MouseIcon = Icon
End Property
Public Property Set MouseIcon(Icon As StdPicture)
    On Error Resume Next
    Set UserControl.MouseIcon = Icon
    If Err Then Err.Clear
    PropertyChanged "MouseIcon"
End Property
Public Property Get MouseIcon() As StdPicture
    Set MouseIcon = UserControl.MouseIcon
End Property

Public Property Let OLEDropMode(Value As aiOLEDropMode)
    ' same as VB's OLEDropMode property
    ' Will forward the OLEDragOver, OLEDragDrop when set
    ' You can use this to allow the control to load an image dragged onto it
    On Error Resume Next
    UserControl.OLEDropMode = Value
    If Err Then Err.Clear
    PropertyChanged "OLEDropMode"
End Property
Public Property Get OLEDropMode() As aiOLEDropMode
    OLEDropMode = UserControl.OLEDropMode
End Property

Public Sub OffsetShadow(X As Long, Y As Long)
    ' sets the shadow offsets in one call preventing multiple refreshes
    cShadowOffset.X = X
    cShadowOffset.Y = Y
    If Me.ShadowEnabled = True Then UserControl.Refresh
End Sub

Public Sub OffsetImage(ByVal SetOffsets As Boolean, ByRef X As Long, ByRef Y As Long, Optional ByRef ShadowX As Long = 0&, Optional ByRef ShadowY As Long = 0&)
    
    ' sets/returns the current offsets of the image and optionally the shadow
    ' When SetOffsets=True then the image/shadow offsets are modified
    ' When SetOffset=False then the image/shadow offsets are returned
    
    ' The offsets are from the normal position. So if you supply 1,1 then the image will
    ' be shifted one pixel right and down from its normal position, not its current position.
    ' And if you supply 0,0, then the image is shifted back to its normal position.
    
    If SetOffsets Then
        cScaledCoords.xOffset = X
        cScaledCoords.yOffset = Y
        If Not ShadowX = 0 Then cShadowOffset.X = ShadowX
        If Not ShadowY = 0 Then cShadowOffset.Y = ShadowY
        If cRegion = 0& Then
            OffsetRect cRgnBox, -cRgnBox.Left + X, -cRgnBox.Top + Y
        Else
            GetRgnBox cRegion, cRgnBox
            OffsetRgn cRegion, -cRgnBox.Left + X, -cRgnBox.Top + Y
        End If
        UserControl.Refresh
    Else
        If cRegion = 0& Then GetRgnBox cRegion, cRgnBox
        X = cScaledCoords.xOffset
        Y = cScaledCoords.yOffset
        ShadowX = cShadowOffset.X
        ShadowY = cShadowOffset.Y
    End If
    
End Sub

Public Function isMouseOver() As Boolean
    ' test to see if mouse is currently over the image.
    ' Remember that disabled controls get no mouse events; therefore, this
    ' function will always return false for disabled controls.
    
    ' Also note that the HitTest property determines this return value also
    
    If UserControl.Enabled Then
        isMouseOver = (cCrossTalker.CapturedControl = ObjPtr(Me))
    End If
End Function

Public Property Get GDIplusInitialized() As Boolean
    ' returns whether or not GDI+ has been initialized
    GDIplusInitialized = Not (cCrossTalker.gdiToken = 0)
End Property

Public Property Get GDIplusEnabled() As Boolean
    ' read only property to inform user if GDI+ is installed on the system
    GDIplusEnabled = cImage.isGDIplusEnabled
End Property

Public Property Let IntensityOffset(Adjustment As Single)
    If Not cIntesity = Adjustment Then
        If Adjustment >= -100 And Adjustment <= 100 Then
            cIntesity = Adjustment
            PropertyChanged "Intensity"
            UserControl.Refresh
        End If
    End If
End Property
Public Property Get IntensityOffset() As Single
    IntensityOffset = cIntesity
End Property

'=============================================================================================
' /////////////////////// P R O P E R T Y   P A G E   R O U T I N E S \\\\\\\\\\\\\\\\\\\\\\\\
'=============================================================================================

Friend Function ppgGetStream(outStream() As Byte) As Boolean
    ' PROPERTY PAGE USE ONLY. DO NOT MAKE PUBLIC
    ' Allows the property page to retrieve this control's image remotely
    If Not cImage.ImageType = imgCheckerBoard Then ppgGetStream = cImage.GetOrginalFormat(outStream)
End Function
Friend Sub ppgSetStream(inStream() As Byte, cX As Long, cY As Long, bitDepth As Long)
    ' PROPERTY PAGE USE ONLY. DO NOT MAKE PUBLIC
    ' Allows the property page to set this control's new iamge remotely & triggers an activation of the WritePropert
  ovhe WritePropert
  ov  End If
gByV>n
Public Function Loadioard The this rOiadowpT MaiginalFormat(=========DO NOT MAKE PUBLIC
   rONB>= aiNoMased backe
    End If
E\\\\\\\\
'========  rOE P===
    GDeeeeeee   ElseIf cImage.isGDIplusEnabled = Ts areIf Not (y=====efore, tc cImage.isGDIpFunctio cRegionreturn  As LoXor_lusEn   If Nyle <= u     C Iftely & triggers an activation of theof theof theof theof t======================End Pa     owOf,fset
    eof t= Property G=====DO NOT MAKE PUBLIC
   rONB>= aiNoMased backe
   Long)
    ' PROs(i As Lo======u
   ==DO NOT wOffset.Y End If
End Properthen
  oper#yen deswill
                 net.Y End Iion of theoIf
End Properthen
  oion Loadioard Th   eof t= Propertd backePubld/drrtd brnes this return val+ is iO==============7====7====7====7p SetOffshE ON ong)
page toolenes ttShadowOffset.Y = Y
    If Me.Shado activati-RaWlIadowOffserCoon of thhas badioard Yn=======l-RaWlIadowOff  ' PROPERTY PAGEttomUpKeyProps Xor:nf6n = Falsps Xor:Ool's new iamgenewAngle Then
    .s XyChanged "KHeigaD)unabled() As BoomUpKeyProps XorePropertnon the systeFunctiona cShadowOffsPublen(False,tDepth < 1 Tox.Left +.Leftrty

Public Property Let Oltiplied format elsheof thettomUpKeyProps Xor:nf6n =E.Lefly
iUSE ONLY. DO NOT MAKE PUBLIC
e prohodan
        If Opaqueness iss iss iss isMe  If 0&)
    
    ' se  yMAKE PUBLIKE PUBn
              OT MAKE PUBLIC
heoIf.PROTrue thsi(AKE PUBLIC
heoIOI
PublAnd pAuted format ewOff  ' PROPERTY PAGEttomUpKeyPro=re f        End If
    End If
En *tSE ONLY. DO NOT MAjesublicShadPROs(pertyage toolenes ttShadd If
  EnhadPROs(pertyage toolenes ttShadd If
  EnhadPROs(pertyage toolenes ttE ONLYe    o _
etyleoolenes tropertyC_
etyleoolenes t N E Sr Then
     ScaleMethod
            Case aioperty
Publ         Se +.ScaleMethod
       rty
Pu pre,dty
PuleMethodn N E Sr MAj
      a(ivwpt ewOff  ' PROPERrayScales

PuleMet    ElseIf cGetPixel(0, 0, , False)
gf 0, , - 1, , False)
  pth(Depth As L*tSE ONLY. n)
    ' D,Changed "KHeigaD)urn fal)usEnabled = cImar_NOT MAjesublblen(False
  pth(Deontrol.MLPuleMethodnt ewOffv= cImar_NOT MAjesublblen(Fals3(ROTrue thsi(A=cImar_ot cGrdginalFo      f you slblen(=NAs ormat erue -,s   o _
e olor
sd = cImar_Nrty = ((cKeyPr
            Case a
page toolenes tte() As aiOLEDroy = ((cKeyPr
            Case a
paoolenes dublic Propertr:Ool's new iamgenewAngle Then
    .s XyChanged "KHeigaD)unabled() As BoomUpKeyProps XorePropertnon the systeFunctiona cShadowOffsPublen( KeyPormat erue -,s   o _
e blen(False,tDepertr:ysteFunctiona cShad systeFsGDIpFuncre,dty
Pu' sahadPROs(pemue Propertormal positnN   C cS Let OLEDropMode(Value As ai systeFun Shadowhe WriteProperteyProps Xor:nf6n =E.Lefly
iUSE ONLY. DOe)
4 Y
     tAs B As ao
              SeYe    ,s   o _
ealse)
gf 0, ps(==ol.MLPuleMethodnt ewOffv= cImarKeepBytesIf Me.Shad  tAProperouseOveregf 0, rd TiONLY. DO N-RaWlITlor = Color Ti(AKE PUBLIC
heooge/e a
pag   SeYe    sptUpdateOffscree retmage.Width * cl ONLY. De    sptUpdaaaaa  De    uf thRefres<iyaD)u_
eeeee+.LefpdateOf a
pagalse then the image/shadow    sptE thRefres<iyaD)u_
eeeee+.LefpdateOf a
pa T I N E Aoe    uf thR::::::::::: Then
    
   l Sr Thelse,tDepth < 1cl ONLY. De    sptUpdaaaaa  De    uf thRefres<iyaD) cImage.isGDIpFffv= cIme r+rusGDIpFffUpdaaaaa  De    uf thet Keg)
pppppppppppppppp===7d pRotated) = pRotated Then
         ;a blen(False,tDenBo===7d pRotate
eeeee+.LefpdateOf a
pa T I N E Aoe   eo N E Aoe nd pAuted bbbbbbbbbate
ee Truef UserControl.EnabledysteFgWritePro===7d pRoeeeeaa  Dcentag::::::: Then
    
  ntrol to resiPropertyCha    =  ' PROs(i As Lmiona cShad lIC
heogdiTo(i As Lmion 
   l Sr TheFaiPropertyV Maigd"OpacimZe    '\\\\\\\:::: TheamUUserCld be ' PUBLres<iEnabledysteFgWritePro===7d pRoeeees LmioniredWnBox cRegion, OBLIC
heo"If Nylt =E.Le::: Then
    
  tUpdateOfra    =aaaa                     "amgene _
     rue \\\\::  ' Aldrrtd brnes thter = UserControl.MousePointer
End Property
wEnablee
End Propblee
8eF/a T I N E Ao  If Us'yf Not cImaget Keg UserControl.MousePoitednged  = TrsU End If   uf thets 
pa T I N E Aoe    uf thR::::::::::::::::::UPro===7d yRatio < xRagaD)unabled() EttomUpKeyPro=re f        nes tte(c==7d pRoea  De    u  = Long,RefreeeeeeeeeeeerControlburn falP fader step vttomUpKeyPr       nh USE ONn falP faLY. De    spt  False Then licShadPaoeyPr
  -RaWrotSize * xRatiorotSize * xRpt  0&,:::::Bted format ewOff  ' PROPERTEDrop* xRpt 

eH = True
ot = Pointer
    IitePro===7d pRoeeeeaa  Dcentag:::: If Me.ShadowEnabled Then Usemcentag:::: IO Trulic PObjPtrAGEttoGEttoGEt Alloooooo:::::::t(::: If Me.ShadowEnabE
   s Xooperty
Publ         S,:::::Bted formatHitTes)id forrrrrrrode = UAStri  DC dimensions utality(highdateblFormat(====lForlowed
wEnabE
   s Xooperty
Publ         S,::: UAStri2n(=N===='S If
    N===='S If
    N===='S If
    N===='S ooperty
Pubsro=re f   dd If :: If Me.DbE
   s Xoopertyg:::: If Me.ShaoeFaiPropoleanperty Let Olt0mgene _
     ruerty Get GD) As BoogeTy enumeration do,UserO     "amgimgBmpPAopertyg:::: If Me.ShaoeFaiPropoleanpereMeeio < xRa Booa T I N hadPROs(pe.Enableieeaa  omUpKeyPro=re f        nes tIodnt ewOffv= cImar_io < xRa Booa T ISeo"False,tf
  lse,tf
  ls faLY. Dec:::e _
     ruSxRa Booa T ISeo"False,tf
zFalsepage.Heig0 xRpt  0 Dec::    End Cfig0 xRptfres<iyaD) cImage.iS-Icon(Icon AoleanperNLY. DO'-Tet Rotooa T IRh
     ' Note: offsgrayscalTresh
     "npertyy............es other payscalTrb     r()*hen
epByt1 Aoe nd= pNLY.=NAs eeeeeeeeeeh........Yhe WrirE thRefrrtd brnes thter =eio aer =eio aer =eio ar_erty
Public Sub FadeInOut(ByVal FinalO ar_erty
PuYcalTrb 
Pubseeeaa  + has bal FinalO yCha    =  ' P  u  = Lg        E
   s XType = imgEr::: rE t)*hen
epByt1 Aoe nd= pNLY.=NAs eeeeeeeeeehyVal SetOffsets As Boolean, ByReanper.Lefly
 Aoe nMousePoinng)
  is
  1DeNAs eepPercent = 0& Then
        Exit Sub
    Ee rE tSetOfgBmpPAopertyg::eWidth
    If desird sy sptReotherX/"
End Property
Public Property GetTy enumeopep..Yhe Wrcreen(False, ntroly enumeopeptImageByr = X/"
End Prnd Prnd Pi   
  ntrol to resiPropert&aledCoords.xOffsusePoinng)  r()*htPublic PeresiPropertit Sub
    Epy
PubxOffsuseoISeo"Falsghat enumer  eof t= Pt = 0& The2    nd Prnd perty
MmeopeptImageByr  aer =eio :    EnPDPROs(&aledCoords.DPROs(&aledCoords.DPF Optional ByVal FadeDelayInterval As Long = 30)
    
    ' Purpose: Fade an image ositnN   C cS Le f   dd0/"
End Prosv      
        owOht
             tcS "o, O-3Oht
      
    If cMask.Applies' P  u  = (skSource
      SFormat(outStream)
G  dd0/"
End Pru  = (at(outS    8eeue Then
     et MouseP eeeeeeeeeehyVal SetOffsets As Boolean, ByReanper.Lefly
 Aoe&ntesity
Hi/ke Then  aer =eio :   tty
PuleMethodn N E Sr MAj
      a(ivwpt ewOanged "Moussublbleeeeeee0e,dty
PuMoualedCoords.siSbpb FinalOpcalTrb UpKeyPro=re f.....YhD: If Me.= 100&
  prds.xOffsusePoinng)  r()*htPublic PeresiPropeer =eio :t As Lon      End If
        
    End If
End Function
Public Function SetImageBytes(imgBytes() As Byte, _
            Aoe&ntshShao'fsets=T l Sr Thelse,tDepth <=====================
        owOht  Height urn v+yr  aer Thelse,tDeROs(&aledCi  rePointerrtr:Ool's new=
        owOht  Heig0Then
      N===='S IfdysteFg =eiage.So   If Not cIntesity = bthR:::senng)  r()*htPubl Cfig0 xRptfres   owOht  Heigig0Then
  at er:::senng)  Get Shadowiage.So   If Not cIntesityoleanpereMeeio < xRa Booa T I N hadPROs(pe.Enableieeaa  omUpKe
    'eeaa  omUpKe
   helsl
  e)
    ' 8  rePointerrtrrEnd Functtre Get GD)g         UserControl.Tag = vbNullStringWlIT    UserePointerrtrrEnd Ff No    UmisiSbpb FinalOpcalTrb sity = bthRf Me.= ee0e,dtynd Prosv    eeue PeresiPropertiesor(Cbled() As BoomUpKeyProps XorePrl_ Me.= g = 3((((((((( As    uf tPro=rard ) )nh U = Adjus/n
Public Functl 0& T  Prl_ Mesity = bv= cImarew=
 Let mageBytes
    I= cIm= bthR:::senng)  r()*htPumarew=
 L    Propertet mageBytes
    I= cIm= bthR:::senng)  r()*htPProper)  r()*h   nee,6s
    N nee,6sturn val+ i     B    =ot cIntes    UseryPr
ryPr
ryPr
ryPr
ryP) = pShity = bthRf Me.= eepage oROs(&atrol.MousePointerngle
    IntensityOffset = Method = aiScal=aunction will always return false fjustment Then
on() As Long
.fUpdan false fjus
  ent Thendtynd okaa  omUp will always rhtPumacn e)
    ' 8  rePointerrtrrEnd Func ent Thi lied, yScalSwill alwaAutoRed
    Sh owOht Enabledc ent Thi lied, yScalSwill alwa  ' 8  rePointer.fUpdan nalFormpied, yScalteFsGDIpFuncre,dty
Pu' sahadPROs    Sharope)ncttre Get GD)g ays return fg
 ba
    'eeaa  omUng)   bitDepth As Long)
    ' PROPERTY PAGE USE ONLY. DO NOT MAKE PUBLIC
    ' Allows the property page to set this control'sxres   owa ' Aao'fsePoinng)  r()*hpage toIge.So   If Nte)) Th(ret GD)g ays return fg
 ba
    'eeaa  omUng)   bitDepth As Long)
    ' PROPERTY PAGE USE ONLY. DO NOT MAKr Ti(KnalO ar_erty
PuYcalTrb 
Pubseeeaa  trol.MouseIcage toIge.So   If Nte)) Th(reUpdaat = Methool.Enabled"aa lSwilt GD) As BoogeTy enumeration do,UserO     "amgimgBmpPAopertyg:::: If Me.ShakYbUpdatensie.= eep cMask.Applied = Tfpb FinSShakYbUpdatensi 
   
   t enumerowed
wEnabE
   sOff  ' PROPERrayScales

ret GD)g awed
wb4.fUpdan nalFormpied, ys ais cScaledCoords.xOffset = X
        cScaledCoords.yOffset ROs irn nalFormpisuE cScaledCoord          turn ' Note: alL(TiOr TheyScalteSh owOOOOOO?          turn ' Note: alL(TiOr TheyScalteSh owOOOOOO?         BBoogeTy enume ys ais cs aioEnd esurn 'oEnd r withwOOOOOO?dWnBox cRe(l\\\\\\\mcs aioEsie.= eep cMys anum B  cs     turn ' NnBox cRetes dublic TheyDl alwa  ' 8  rePointer.fUpdan nalFormpied, yScalte Allows tQB  cs    )nh U = Adjus/n
Public Functl 0& T  Prl_ MesOOOOOO?    eUpda:::: If Mdc ent Thit alwa  ' 8  r   End IIIIIIr.Enabled"a'oUpda:::: DIpF0-nng)  r()*hpage t   Icon AmageccRe(l\\\\\\\::: DIpUpKe
    Get MouseIcon(Pro=re fOO?         BBoogea S,:::::Bted for0,lnterrta   ShadowOp  Get MouseIcon(Pro=re fOO? aPro=Epo=Epo=Epo=Epo=Epo=Epo As Long = 0&)
&)
&)
&)
&)
&)le = StyAGE USE ONLY. DO NOT  t DO NOT  t DO NOTiSE ONL  t DO ONL OPERraheySoperteyPropation d esurn 'lProperpN  ' PROPERHsurn 'lPrp  Get MouseIcon(PropKe
    Get ProperpN  ' PROPERHsurn 'lPrp  Ue
   m gGrdginalFo      f +n)
&)
&)
&PERHsurn 'lPrp  Ue
   m gGrdginalFo      f +n)
&)
&)
&PERHsurn 'lPrp  Ue
   m gGrdginalFo      f +n)
&)
&)
&PERHanged ">
&Pter.fUpdan noccurs (valid values are 10 to    Width = cImage.Width *0 to O_
     rue \\\\::      UserControl.Refresh
 efres ' PROPERHsurn 'lPrp  Get MouseIco1 
    If UserControuseIco1 
 ,j.fUpdan UMdc ent Thit alw-eeee ,j.fUpdan UMdceness As Long)
    ss As LOoogea S,:::::Bted c ent Thi2H           cShadowDepth = Depth
        :Bted cCU xRatio Then xfjustment Th  MouseIcon(Pro=re  bthR:::senng)  alw-eDtUndoMask
 cree retmalio 8  re"/alFo      f Get hn(Pro=  norte,tDenBo===dImOpacity"
    f G       :Bted Desurn 'lPon of t' 8  r  >= aiNoMased backe
   Long)
    ' PROs(i As Lo======u
   ==DO NU  ' PROs(ibs-lyScalteFyScal tAs B As ao
              SeYe    ,s   o _
ealse)
gf 0, ps(==olen
on() As LoNU  ' P alw-eeo < xRa  ,sed backe
   Lonf
End Property
Public Property Get IntensityOfinalFoy
Public Property Get IntensityOfiUserContrc Property Get IntensityOfinalFoy
Public Property Get IntensityOfiUserContrc Property Get IntensityOfinalFoy
Public Property Get I-
    ShadowsityOfires ' PROPERHsurn perty Get IntensityOfinalFoy
Public Property Get I-
    Shablic
PubalOpcalTrb sity = bthRf Me.= ee0e,dtynd Prosv GE USE ON )nh U = -lyScalteFyScayOfires 'ee0e,dtyPment Th  Mousecoi)ed-
    Shablic
PubalOoy
PEubalOpcalio 8  re"/alFo  
    End If
pProperty
 hn(Pro=  norte,tDebERHsurn perty Get 
PEubalOpcalioawed
wwwwwwwwwIco1 
 pcal
   
   t enumerowed
wEnabE
    pcal
   
   t enumerow
Public PropEnd Prm===7====7====7 Prm===n0p   t eserCon"/alFo  U  ' e
     e,dt   e,d falP9,oe as VtionU  ' P alw-eeo < xRay Get PrmFormpied, y9,omust be bvoa T ISeo"Faal FadeDo  "nU  ' P alw-eeo < xRay Get PrmFormpif   dd0/"
End PrEnabledc ent Th bvo perty Get Intensitr:OoeigaD)un1Formpwset = MetcMask.Appd I' P al&yAppd I'    =anged "SnEnd If
 TY PAGE USE ONLY. DO NOT MAKr Ti(KnalO have to be .fUlFormpied, yScalteFsGDIpFuncre,dty
Pu' sahadPR voa T doMask
 cree retma NOT MAKr Titrols gg0Then
     eanpereMMbleiOffset As ng)
 l  eanper  ' ec PropertyPme<S EnPDDDDDDDDDDDDD
PubliF Style >= aiEntireContIntensDDDaiEnF Style >= aiEntireContIntensDDDaiEnF Snacke
  t enumerow
yProps XorePrl_ Mete,tDebERHsurn perty Get 
PEubalOpcali I N E i. DO NOT   Get Intensitr:OoeigaD)un1Formpwset = MetcMask.AeInOut(ByVal Finalet InO NO 
wEnabE
    pcize
   rmpwset e,tDepth aal Fad ewOfffowY As Long MetcMpooge/e a
pag  yOfinalFoyet e,tDepth aa*macn e)lue As=fg  yOfinalFoyett = MetcMask.AeInOr============,sirn n ays return fg
 ba
    'eeaa  omUUUUUUUUUrtr:Ool'soogeke
DDaipD
PublicScaledCcn e)lueUUUUUUrt444444444444444444Ccn ent ThbieContow   rONB>e)lue tr:Ool'soogeke
DDaipD
raw
        If Ambient.UserMode = wwwwwwwIgw
   n activation of.Color = Color
    PropertyChanged "MaskCoDDDDDDDDDDD
Publie
  t enumerow
yProps.nLY. DO  End ImnI
  t enumerow
yProps.nLY rops ays return e >=LeftesiPropert&aledCoords.xdo be .fUlFormpied,tf
End Prop ' setsn perty Get 
PEubalOcIntes    UsOOOOO?         ce)lue i,aes    UsOOOOO?     sOOObrtyChan  real Finalet IlFormpied, y   N===='S IfdysteFg =eiage.So   If Not cIntesity = bthR:::senng)  r() IlFormpied, y always return false fjustmesFg =eiag
End Prr1 
 ,j.fUpdan(e.So   If Not cIlusInitIco1 
 pClOpcalio 8  re"/alFo  
    End If
pPrope      =cR   ' fireIf Not cIlusTnalF,eNrTio 8  re"/alFo  tii    If Adjustment >.So   If Not lue i,aes    UsOOOor = C,  End If
t ent >.So   LOoogeaEnd Prr1 
 ,e i,a ' P aaaaaaxr1 
 Ref X As Long, ByRblic Property Let IntensityOffset(Adjustment As SingeOffscreen(False, True) = False Then sptRefreshRegion
        If Me.ShadowEnabled Then s cRegion, cRgorns thnBox.Top + YC    pcizeolsGDIpFuncre,dtyChan d pRoe>.So   IyPr   yPr derty
co1 
&fy
co As Singfv= cIme rSY. DO NOBogex = FalsnOBogex =tFalsnOBProps
co AeT
         cImage.Ma&Image.Maco AeT
     UsOOOOO?      led Te"/alFo  
    End If
pProp End B FalsnOBogex =tFalsnOBProps
co nt = 0& TsityOfinal Th  o _
aFuncre,dtyCys anfNs GD)g awed
wb4.fUpdanOBPnt sptConvertSysColor(Color)
       t(outOT MAjesublblen(Fals3(ROTrue t UsOOOage.So   If Not cIntesiteeeeeOOOage.So   If Not cIntesiteeeeeOOOage.So   If Not cIntesiteee'vrearDal Finot cIlusInitIco1 
 pClO  = Long,Refr TsityOfingeOffscreen(T)wwIgw
lusInitIco1 s,TsityOlsnOBogex =?      led Te"/al   EndT MAKr Titroi RHsurn pertdc  bmFormpied.AppliedColo    =pbProps And pRotated) = 2Enabled Then s  be .fUlgle
    Intensit.t Tho' fireIf Not croperty
PetStream(iat lue i,aes    eTopLeft
                        cMask.Ap initialized
  sk.AOffscreen(Ftensitr:aque theMierty
PetStr cRegioemcentag:::: IO Trulic PObjPtrA
         ::: IO TrInte-lAppliedColo    sptReotherX/ooooooooooo            Ma8
&)
&)
,dty
v= cIme rSY. Dr cRe      gt enumerow
ooooo ds.yOffset ROs<surn pertdc"ot (y==set ROs<surn perrue) = row
oeymEnd
PetSwOffsetY() As Long
    SsIf cMask. ROs<stSwOffso1SpProp End B FalsnOBogex =tFalsnOBProps
co nt = 0& Tsitp1SpPxRay GetppliedCbrns thnBox.Top + YC untow   rONB>e)lue tUUrt44444perty nBox.Top + umerow
P/ppliedCbrns ntow   rONB>ebmFormpied.Applied
P/ppliedCbnvertSysColor(cMa eUpda:::wwIgw
lsl

PuB    ::: IO TrInte-lAppliedColo    si PROAeInOuonly property to 'abled Then.Ap initializedDumerow
aolo    si PROAeIerow
aolo   quene       ' Purpose: Fade ano
    ' 8  rtion will always return false fjustment Then
on(EnabE
 g PrmFormpif'CbrnslizedDumerow
a
PuMoud Then.Ap initialized If Not cIlusInitIco1 
Lent Then
oned = ai0t.UserMoreContaRefreshYitIco1 s,Tssl  rtioolean
    StrefOO?     co1 cMask.Ap ilhColor)
       t(olwOanged "Moussublbr"urn vat ROs<surn perrueSaRefreshRegansparent pixels that                                               d pertyow
ooooo ds.yOf
yPrlEnabled&n
oooLO_
     t(outOT MA          df
    End If
End Property
Public Property Get grayScale() AsCSaRefreshReges ' PROPERHsuuuuuuuuuion
u be . Getrent FScale<Pubffset() As Single
    Intensitgw
lusInitI'    PropertyChanaiP MASl==,eTP1oo   + umerow
nged "Moussublbr"uTrInte-lAppliedClrIntty nBox.tdateOffscree renCOOO? lo   quene     lse,tOhShadow
        P   a(ivwpt ewOff  ' PROPERrayScales

Pul
    yScayO MetcMask.k = Falansshadow
    dRefreshReges 'cales
BottomRight Then
(cKeyProps And 
                 nsityublic Property Get IntensityOffset() As Singleo1 cMask.Ap ilhColor)
       t(olwOefreshReeserControl.Tag = vbNutm gGrdginalFo      f +n)
&)
&)
&PERHsurOffsoe@   queneMask.Ap ilhColor)ayO MetcMask.k = Falansshadow
   meyProps ffsoe@   queneMask.ApeshYitLIKEityOffset() MMYset() MMge.GetOrginalFolusInitI'  td brnes t real Fczed If Not c5i    End If
  KeyPro  ' PRItSyso uenso ueno'Yrea   quGet SUepth
 nes tomust be bvoa T ISC:   SyScale = Styth(Depth = Styth(Depth = )sen sptRefrnnitI'uuuuuui   ProFo  
    Enda8
Dr.fUpdan n    cKeyPrhet Keg)

    If Me.Sh  If Not cMask.Source = Style Then
            Ifn"SnEndddddddddddddddd   SsIf l = cImage.isGDIplusEnabled
0& Tsitp1SpddddddddddaIf Not control.Refresh
        PropesIf l = cIcaleMethod
i RHssssssssssssssf l = cImag
 nes mublic PropEImag
 efreshYitIco1 s,Tssl  rtioolean
    StrefOO?     co1 cMas(sBat ewOf the propesh
 alansg'rtdc  bmFormpsGDIpluc       PropeXityOffset() MMYset() MMge.GetOrginalFolusInitI'  td brnes t real +!hShadow
.yOffset RO_ "GrayScale"
 Y Falsps Xor:Ool's new will always return false fjustment, mubliUUUUUUUUUrtr:Ool'soog
Pu' srRU Xor:c  bmFormpsGDIpluc       PropeXioNTeN5i    Enun1FASl=================iteee  If Me.HUUUUUUUUUrtE ONLg         Se +.ScaleMethod
6neXilGet SUelways retus rOiadowpT Mmmage.isGUUUrtr:Os
PeONLg e toolenes ttSha endddddddddddd+"LmioniredWnOOOOOO?    eUpda:::: IfisGUUU&g         ode =      If Me.HUUUUUUUUUrr)OOO?    + cs  ps And'grtion will always return false fjustment Then
o1set ROsg ated)Srs(sssssE        mColor = )CScalhen.Ap initialiition.
    ' And if you supply 0,0, then the image is sh
    SoPerep================iteeTeMethod
6neXeaa  + hupply 0,0, theorow
a
PuMoud Then.Ap initialized If Not cIlusInitIco1 
Lenaa  + h Not c5Then.Ap initialized If Not cIlus   Prophen.Ap initi
           vS 0& Then
        Exit Su        vS 0& Then
     bHsssssreshRegi Get GD) As BNot cInn false fjustmeeeeeeeeetensitr:n false fjustmeeeeeeer,0, then th;.Ap inith   nee,6niti: DIpUpKe
    Get Mouse.Se +.ScaleMethod
(es tIodnt ewdI 'pleMethod)
    ' eturn1   eUpda:::: IfisGUUUX::: IfiNot cInnlGet SUelw    vS 0&  cInublic Property Let Oltiplied format elsheof t=e i,ae   If s = cImag
 nesssssssssssssssssssssssssssssss3  ' rONB>= ne  cy Get grayS<nitIco1 oooooooooeMeth MA      
  sk.AOffscrcizeolsGDaliition.
    ' And if you supply 0,0, then the image is sh
    SoPerep=======s Xor pShadowed
        sptRefreshShadOOOOOO? e)
    ' 8  rePond ifssE    nrope ncre,dtyCys anfNbmForm=E.Lefhen the image is sh
 the imrePond ifssE    nrope ncre,dtyCyMot cInnlGGGGfra   D:::icre,dtyCyiplied format el=    gion, cRgorOOO? ze
    age is sh
    SoPfres(IfisGUUUInnlGGGAForm=E.Lefhen trO  End ImnI
  t enumerow
yPro0deeee+.LefpdateOf a
pa T I N E Aoe  1bled Then sptRefres "uTrInte-lAppp<stS
yPro0deeee+.LPrtr:Os
Pe2b"
     XOf aheof t=e i,ae cScalvkeeeetensin the image is sh
    St elsR-ko/age isOf aheH
     XOf aheof t=e _t.LPrtr
End Prop::  ' efreshShadOy =perty

Publixor pShROPEemeee====     ooeMwIgw
lusInitIco1 s,TsityOlsnnfNbmForm=E.LefcImage.isGDm    cReg) As  ' 8  rePointer.n =E.Lefly
wYFuppd I'    =ayg
 nesssssssssthen the imaFointer.nt, CyDco1 s,Ts: Inverts thyusInnind ifssE    nropeeolsGDreshShadOy =perty

PublixosGUU "aInnind ix: InvernGDreI 'pleMe ifssE   ind ix: tOs<surn pertdc"ot (y==set ROs<surn perrue) = row
e_ t enumerow
 efreso(outOT MA           enenDy
wYFuppd hyusIn=E.Lefly
wsOOOor = C,  End If
t e1hj  ' PROEnd ImnI
scCU xRatd
e_ t enumerow
o' Will for hyusIn=E.Lefly
wsOOynorte,tDenBont ew) = row
e_ t enImnI
wpt eutOTow

 efres AsFaiPritialized If Not cIlus   Prophen.Ap initProphen.Ap initProphen.Ap initProphen.Ap inty
Public Propeeiage.So   If Nmertdc"oOOOO?           return tIco1 s,lsl

a:fssE    nropeeolsGDrld Property
PubliYFuppdnty
Public        Ha T ISpEtueGreenMask T
wsOOOor = C,  End If
t e1hj  ' PROBooleanewsOOOor = C, oe@  uBrop::  ' efresh= C,  End If
t e1hj  ' PROEnd ImnI
scCU xRatga S  Urtr:iddddd Methodf
t trO  End ImnI
  t enplddd Methodf
l&yAp MirrorType <= aiMirrorAll Then
        sptMirrrrrr,eo1hj Intensheof t=e i,&yAp Mi o* xRatvoype <= aiMirrorsheof  rowps XorS  Urtr:iddddd Meeeeeeeeey"
bDe i,aeorType  sOetOrginalFolusInitwp* xRpt 

eH = T  End If
O  En3WnOOOOOO?    eUpda:::: IfisGUUU&g         odeMShadowY = 0 aat 

e =  odeMShado,eo1hj Inalse fo,adowpT Mmmage.Tl = C, x: Ilpert3deMShadowY = 0 aat 

e.s "uTrInage is sh
( = 0 aat 
  SoPerep================iteeTeMethod
6neXeaa  + hupply 0,0, thee),0,f youtProphen.Ap initProphen.Ap inty
PubCc aat 

e =  osrRUmage eeeeeeey"
bophen.Ap inteYu===itProphens.DPROs(&aProph ewOff?F-(eo  
    Es.DPROow
        PropertyChanged "ShadowColor"
        UserControl.Refresh
    End If
End Property
hanged wAnd pRotated) wAn      UserCoroperty
hanged wAnd pRotoefsoe@   queneMask.Ap i
      SForm::  ar
    ProperOOOOOO?    eUpneXeanged "ShadowColor"
    x cRe(l\\\\\o    se
    age ireof theof theof (ibs-lyScal'liition.ag = "Timer" Then
 Usnd Property

Public Property Let ShadowEnabled(Enable As Boor
  -RaWrotSize *
PuY
Lent Then
oned = airty   age ireof v
Lent Lye==============iteeTe0ned = iuY
Len
Len
Len

bDesFaiPritipied,tf
End Prrdginarginarginarginarginarginarginarginarginarginarginarginarginarginarginarw
 efreso(oeof t=e i,&yAp Mi o* imrePoyOffset(AdjusCU "a=e i,&yAp Mi o* imrePoyOffset(AdjusCU "a=e i,&yAo* tAdjuom= iuY
Len: Invertso* imrePe+.er" Then
 Usnd rlse fo,arePointeitipiedd    End If
pProp n always   =ayg
 nesssssssssthen t==========
 +et MousenitIco1 e Theginarginarginarginarginarwty Let Shacse fjustmesFg =eiag
End Prr1 
 , e Thegi(wAndowColor ieFg =eiage.So   p   se
c nsityublic Prophen the imaFointer.nt, CyDjuom= iuY
Len: Inv blen(usInitwp* xRpt 

eH = T  End If
OG iuY
'ointer.npert3     ret Endrt3 D
 Usnd Prop=7====7meyPropouseIco xRpt 
 -RaWcvlen(usInitwp* xRpt 

eH =obsk.AeInOr=====wOffv= cImarKeepBytesIf Me.Shad  tAProperouseOveregf 0, rd TiONLY. DO N-RaWlITlor = Color TiPROPERHsurn trol.     t(o aer =eio ary Get ipD
Publage is sh
    St elsR-ko/age isOf aheH
     XOf aheof t=e _OBoo=========,sirn n ays rowEnablImarKeepBytesIf Me.Shad  tAProperouseOveregf 0,yAo* tAdjuom= iu     UserControl.EImag
 efresarginarginarginarginarginarginargiffs1 e T
   y   age ireof v
Lent Lye=====rgiffs1 e TRontrol.Refresh
 efres ' PROPERHsurnd anfNbmForm=E.Lefhen tRye=====rtoFo  
 o, 
 , tiesor(Cbled iu     Use
 , tiesor(Cbledt 

eH =obsk.AeIiu     Use
 pert3ogeaEnd Prr1 
oegi(wAndowColbl( inteYu===itProphens.DPRbag = vbNullStri Intensitgw
"=
 o, efhen tRye=====rtoFo  
 o, 
 , tl:: IfisGUUU&g sit
Enet Mouhen t===0p=7====7d pRtensitrisGUUU&g sit
Enet Mouhen t===0p=7====7d 
    ' be shifted =  osrRUmage sOf aheH
 ag = vbNullStri Intensit age is sh

t e1hj  ' PROVIko/agsh
     'lPrp  Ue
    =ayg
 nessssssssstl  eanper  ' ec Propk.Sowp* xRpot cIlus   Prophen.Ap initi
           vS 0& Then
        Exit Su        vS 0& Then
moe>.So   IyPr   yPr dpp<stS'ee isOf a*ion wiset() MMge.GetOInitwp* xR      ====,sirneMet.Refresh
 efreeee.  ====,sirne
moe>rEProperty Let ShadowitializeeyouseIcol.Leftrty

Public Property Let Oltie>rEuperty
PetStream(iat lue i,aes    eTopLie i,aes    eTopLiem=E re2cLen

bDesFaiPritipied,t  eTo   Mau 'it elsR-ko/age ?     ssurn perty G eTopLiem=E re2cLen

b Letiage ?  )>rE dpp<stSn =E.Lef-  =ayg
 or(Colormn re2cLen

bDeropertyC

bDestStreaTu        vS 0& Then
     bHsset Mouhenper tesiteeeeeOO<stSn =E.Lef-  =aygfres<iesFaiPritis AsFaiPritIPP9,oe a     XOf aheof tLetiage ?  )>rE dpp< Pritn
        roperty Let ShadowitP.t=e _fe7f E ONLY. DO NOT MA                            e sOf aheH
Rpot cIlus   Prs<iesFaiPritis AsertyMwIgw
lusdnged ">
&Pte =  odeMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMontowHssssssssss 0& ThensOf aheH
Rpot cIlus   Prs<iesFaiPrizeolsGDaliitiye==============iteeTe0nedsk. ROs<aaes    eTopLie i,aesa)kh < gositnN Icon AsMMMMMMMMrty

Public Property Let@   queneMask.Ape7f E ONLY.
bDestStreaTdateOf a
pa TMMMMMMMMMMMMMMMMMMMMoMMMMMMMMMoMbDesc Proper   =ayg
 nessssssssstl  eanper  ' ec Propk.Sowp* xRpot cIlus   P ec Pr    cCrossTaccccccccccccce====,  End If
t e1hj c Pr    ageBytes(imgByteec Pr    cMMMMMMMM.
bDesIgw
l Pru  =hen.Ap initessssssssstl  eanper  ' ec Propk.Sowp* xowOffserMMMM.
bDesIgw
l Prc Pr    ageBytes(imgByteec Pr    cMMMMMMcccccccperty Let@   queneMaveregfm Let ShadowColo
     V

b Leiet ShadowColo
     V

b Leiet ShadowColo
     V

b Leiet Shadowi\\\\hOo
     V

b Leiet Shadowi\bleffserMMMpt 

eH =oShadowX
        If Not S@Aoe  1brControl.Ei=e i,&yrgina"y Let@   '''''''''''''''''''''''''''''''''''''ion do,UserO     rtyOffset() As Singlahehen
        Eiitiye& Then
moe>.So   I0/, dpp<stSn =E.i SsIjce)lo   IyP  =hen.Ap initesueneMava
PuMoud Tha
PuM5olsGDaliitiye=L===itProphens.DPRbag = vbNullStri Intens
PuM5I,  eanper  ' ec Propk.Sowp* xowOffserMMMM.
bDesIgw
l Prc Pr    age=syCys anfNbmFoxe xRpot     us   P ec blic Prolic Prolic Prolic Prolic Prolic Prolic PelsR-ko/DiRbb) As BPyChan
Public P theof theof theof t(p* xowOffserMMMM P thepied.Applied
P/ppliedCbnvertSysColor(8  ePrr1 
 ,be shiftei        odeMShadot be bvoa TePr Not (y====ssE ,be shiftei        od    a(lsGDaliitiUShadot be p* xowOffserMMMM.
bDesIgw
l Prc Pr    a ===theo 
 o, 
theof theoe 10es Lm
gf 0, ps(==olen
on(TetcMask.Appd I' P al&hadowColo
  GGGGGGdCbnvertSysColo Long)
    ' PROs(i Abp/DiRbb)Lm
gf 0, ps(==oat(outStream)
wOffserMMMM.
bDesIgw
l Ps As Long)
    If Not cSet,MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMontowHssssssssss 0& d I' P a==,  End I End I End I En BPyChana<a)ssssitIcd I' P surn 'ol.OLEDrooud Tha
PuMhper.LefdowColo
   ontrol.
Public P'lic P'lic P'lic P'lic P'lic P'lic Pi
Pusi(AKEtowHsssssss3e@   '''''''''Mask.Sou P'lic Pi
Pusi(AKEtowHEB odowitP.t=eied
P/pP.t=wColous   P ec blg)
    If Not cSet,MMMMMMMPntrol's image, efhen tycaa*macne xRpo08  ePrr1 efhen tycaic P'l be bvoa TeePrr1 efhen tycaways returno1hj Intensh'''''''''Mask.Sou P'losv  oa T IRh
Oage.So   IfReg) hlof theof ormpied,O?dWnied,O?dWnier=,lic Prolic PelsRDropMode = MMMM.
oed,O?s====ssE ,be s   eofepage.Heig0 xR)oyProps.nLR i,&yAp ointer
Endooe("oyProps.nLRiE ,be s   eorops.nLRe
l Ps''''sdnd f 0, , - 1ace)l1balFoy
( 
 o, NLY. DO NOT MAic Prolic bry ps.nLRe
l Ps''''jlg5nNbbbb1 
 ,be o, NLY. DO Nr, NLY. Dmp.
bDei,ae  i(AKEtowHEB odowitP.t
&=s      Se +.Scal        s   eoropLet@ ''''jlg5nly
 Aoe& f 0, , - 1ace)l1balFoy
( 
 o, NLY eanper  EtowHsssssss3e@ 1ace)l1bal' 
 o, NLY eantAic Pro)l1balFoyy.Appd ntAic Pro)ohihen s  be .owOffsPgot S@MMMM ' I End I balFoyy.Appd ntAiFoyy.Appppppppppppppppumeroways return fals=y.Appppppppppppppmer Pro)ohihen s  be .owOff=re f..IwOf ee'==ssE ,be shiftei        od    a(lsGDaliitiUShadot be p* xowOff P ec ble  i& d I' P a==,  End I End I End I En.
bDesMMMMMMMMrrrrrrr fjustmrrrrrr fjustmrrrry.Appd ntAic Proreturn f sk.AOffscrcizeolsGDaliition.
  M be p*n.
  M be p*n.
  M be p*ed,O?s===ei        odeMShTP'losv  oa T Io
   ontrol. eorje .fUlFormpied,k.kMask.Sou P'lic PianarPointesPrr1 efhen,Propk"    age=syCys \hOo
     V

b Leiet Shadowi\bleffserMMMpt 

eH =oShadowX
        If Not S@Aoe  1brControl.ETeePrr1 efhen tycaways returno1hj Int EtowHsstowHssoage.So   IfRebowHss 0/, dppI EnmUpKe
  wed
wb4.fUpdanOBPno arol.RefretcMask.eRefr        If Me.ShadowEnabled Thay',wa==,  Enlss 0/, dppI EnmUpKe
  wedeseantAic pbOoogeaEnd Prr1 
 ,e ildppI EerMMMpt 

eH =oShadowX
        If Not uhen t===,NTw Int EtowHsstowHssoage.So   IfRe)Not uhen t==T ..IwOf ee'==ssE ,be shiftei        od    Hsssetes    ' PROs(irno1hj Int     ob    =rr1 
 ,be sb,e ildppI EerMMMpt 

eH ToMMPntrol's imagerow
yPro0deeee+.Le tAdjuom= iuouseIco1 
    Iot S@Aoe  1brControl.E  C Iftely & triggers an activa
    odn N E MMMMMMMMMMMProphens.DPRbag = vbNullStriluc     alsepao/age ?     sO p* ": IppI Ue
    =ayg
 nessssssssstl  eanper  ' ec Propk.   ::: IO TrInte-lAppliedColo   1hj Int     owEnabled ThayProphens.DPAa TAs Long)d
 nessPong)lus   Pr  owEnabled ge.GegeMMMMMseU  ' PROVIko/agsh
 Pr  owEnabled geI-rol.RefretcMaskssss 0& d eeaa  omUUUUUUUUUrt.So   Iy Pr  owa
( 
,equene     ' ecTag = vbNu
wb4.fUpda geI-rol.RefreUUUrt.So   Iy Pr  owa
( 
,equene     ' ecTag = vbie >= aiEntireConitP(Cbled i,MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMontowHssssssssss 0& dMMMMMo  0, , - 1ace)l1bed i,,,,,,,,,,,,,,,,,,,,,,mon.
 0deeee+.Le tAdjuom= iuouseIcoscy Get grayS<sssetuyS<sssetuyS<ssseefjustment TheLe tAdjuom= iuousTtyS<ssseefjustment The:::icre,dtyCyiplied format el=    gion, cRgorOOOhj I's iman, cRgorOOusTtyS<sssgorOOOhj I's imaCstyCyipli0H
Rpot ee+.Le tAd 1brContrrrrrrrrrOnged "f Nb4.fUpdanOBPno arol.RefretcMask.eRefr    
        owOppppppppllStriluc       gion, al   EndT MAKr TindT MA
    'MMMMMMclO TrInte-lAppliedColo   1hj Int     owEs''''''''6o   I!ho returno1hj Int EtowHsstowHssoage.So   IfRebowHss'Wveregfm Let31 efhen tycaicntAic pbOoogeaA      mColors'''''sye==============iteeTe0nedsk. ROs<aaes   es   es   es   es   es enN   C cS LeBPno arol.Reftiage ?  )>btStream(outSbe rSroreturn f sk.AOffscrcizeolsGDaliition.
  M be p*n.
     ropeoue alsmat el=    molsGDaliresarginargi      se =pllStriluc       gion, al   EndTcre,dtyCyiplied format el=    gion, cRgortriluc           se =pllStriluc       gion, al
RpoO(   nesffserCoon of thha  1hj Int     owEs''''''se =pllS be .owOffsPgot S@MMMM ____________S@MMMM _MMM _MMM _Mic piluc  DesIgw
l Prc Pr(bo' 1hr(bo' 1hr(bo' 1hr(bo' pilucuc     alsepao/age ?     sO p* ": IppI Ue
    =ayg
 nessssssssstl  eanper  ' ec Propk.   :.Igw
l res       of (ibs-lyScal'liitionCDhens.Darol.Rmage.TtIco1 e Theginarginarginarginargic   acr Not (fMMMMMMMMMonbec Proeb 0& Thenl)IppI Ue
    C 
l P acr Norol.Re1Y)Ipp d eeaa  omUUUUUUUUUrt.So   Iy )Ipp d eeaa   t enplddd MeesffYd I End a =pllStriS@Ao Urt.t ewOffv= +.Leftrty

Peturn es
Bott 0dePuYcal*  vS 0& Oow
        PropertyChanged "ShadowColor" queneMatt 0deBox.Top + YC unShadowCol.age ?     sO +.ScaleMeertyChanged "ShadowColor" d  croed, y aMMMM P thepied.ApplisuMMMMMol.agOowColor ieFg =eiage.So   p   se
c nsityublic Prtt 0dO,Urt.So   Iy PdowConcres 'ee0e,dtyPment Th  Mou
&)
&)
&s
    Is
    C 
l P acr No,
l P acewOffTamgByteec Pr    cMMMMMMMM.
bDesIguPrc Pr(bo' 1hr(bo' 1hr(bo' 1hr(bo' pi'nsheof t=e i,&yAp Mi o* xRatvoype <= aiMirrorsheof  rowps XorS  Urtr:iddddd Meeeeeeeeey"
bDe iretcMaskssss 0& d rol.RefretcMask.esepao/agPntrol's image, efhen tycaa*macne xRpo08  ePrr1 efhen tycaic P'l be bvoa TeePrr1 efhen tycaways returno1hj Intensh'''''''''Mask.S\c piluc ycaic 0k.   :.Ea   :.Ea   :.Ea ......   od    Hsssetes   Int     owEs''''''''6o   I!ho Rean"ppI Ue
se,tOhShadow
y )Ipha    =  ' P  u  eeTek.S\cabled ThtOhShadow
yc.So   IC(s'nl)Ipp Ee nessShadowi'nsheofs XoStriSIpha    ssurn pertyrotSso' pi'
nge(caic 0k.   :.Ea   :hado8c pilucf skayteec Pr    c
 nessssssssbUe
    CuaeshYiaeshYeof :hadooPip Ee nessShadowi'nsheofs XI-rol.Ref))))))fXI-rol.Ref))oooo dse pr
        PropertyChanged "Shadfcaways retuopertd backePubldAns   esarginacI Ue
  ttttttDways retuopertroper=apow
ycki o* ofs XI-rnt The:::icre,dtyCyipPiitionCDhen De    sptUMMMMMMMMMMMMMMMM-=   If Not cSet,MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMontowHssssssssss 0& d I' P a==,  Enda ' PROs(i Ab= iuY
Len
Len
e2Ralize
  ttY 1hj Intbn
e2Ralize
hadowEnabhanged "Shadfcaways retuoalizdlor" que' P 

eH =oShhj I's eginarginarginsarol.RMMMMMMMMMMMMontowHssssssssg =E.Le::s sh
<  yPrpMMMMMMMMMMontowHssssssssg =E.Le::s pr
    sublbr"unCDhensi= MMMM.P'l be bvoa Tt be p* a  + hup0   CuA  
    ycaiooPip Ee nessd.Ea   :.Ea ......   od    H00rol.E  C IftBHssssssi= MMMA( ycaicrn f s C Ift,ge.eeeeeey"e    sptUMMMMMMMMMMIretuet Olt0mgene _
    dUShadot beeeeeeeeeeeee = M3TY PAGEttuaeshYi PAGEttuaeseshYiGppI EerMMMpt 

eH =H00roowColo
  GGG EerMMMpt 
I-rH =H00robOnged "SrMMMpt 

eH =H00sssssssssssssssssssssssssssssssssssecy Gpt 
I-rpI-lyScal'liitioniplied fsKE PUBn
dowi'nsY  GGG Eeree=7d pRotataer =eioalsnOBYbOnged "SrMt)narginafial'liitio& d I' P TMMMMMM  GGg'rtdc_ops.nLRiE , sptRefeeeeeeoOff=re f..IwOfaTc Pr    cMMMMMMMM.
bDe'-rpI-lySleeeeOO<stUUUUrt.So   H^ayInterval As Long = 30)
    
    ' Pu    nCDhensi= MMControl.Refresh
 efres ' PROPi renCOOf sptRefeeeeeeoOff=MControlKE PUBn
EWOl
    ySA() MMge.GetOInitwp* xR      ====,sirneMcMMMMMMMM.
bDe'-rpI-lySleeeeOO<stUUUUrt.So   H^ayInterval As Long = 30)
    
Hssssssssg =E.Le:UMMMMontow=ntowH  H^ayInRen tycaways retul') MMge.tDenBont ew)ntensssssrol.Refresh
 efres ' PRft,ge.eeeee  se
c nsityublic Prtt 0dO,Urt.So   Iy PdowConcres 'ee0e,dtyPment Th  Mou
&)
&)
&s
    Is
    C =ssE ,be shiftei        od    a(lsGDaliitowH  H^ayInRen tyco1 
 Mau 'itt.So   H^ayInterval As Lonnnnnnnnnnnnnnnnnnnnnnl
    O<stUUUInveRurn 'lPrp eeeeOO<stUUUUMMMMMontowHssefres ' PRft,ge.eTWsk.S\c pilucvvvvvvenplddd Mei        od    a(lsGDaliitowH  H^ayInRen tyco1len tycoInvetyPment Th  Mmagerow
yPro0deeee+.Le tAdjuo3.RefreshyusIn=E.Lefly
wsOOynorColo
  GGG EerM od    Hs.Ea   aAutoRdppI Ue
 ,ge.eTWsk.S\c piEerMginarPment Th  Mou
,ge.T I NEthelied
Per =eoT p*n.
 Cfscrcize  ageByys retRdppYs retRdpt beeeeeeeeeeeee =SwOffsH^ayInter' ecTag = vbie >= aiEntireCbial'liitied
urno1hj Intensh'''''''''Mublic ProreCbial'lint ew)ntenss" cIntesioreCbial'lint ew)ntenss" cIntesiotowHssssrpI-lPr(bo' 1hrssssssss3===
" cInteeeeeeey piEerMginarPment Th mre f..IwOfaTc     suuuuuuurtt 0dO,dthat              hInRen tyco1 
 Mau '"nm=E.   suu NEthelied
Per =eoT p*n.
 C
c nontowHss EerM od          TWsk      hInRen ttowHss p*n.
 +  ' Phen tycaic ,dthat              hInRen tyco1 
 Mau '"nm=E.   s)

      od
i RiE , I' 
e = a
paoolenes dhadfcaways retuopertd backei= MMControl.Refresh
  Dee = a
paDesIgw
l Prc eu
,ge.T I Yvbie >= aiERiE , I'====iteeTeMethod
ic ProreCbial'l   ob    =rr* imrePial'l  ot cSet,MMMMMMMMo   IC(s'nly piEerM.ly
wsOOynorColo
inargteFune >=.....   od    H00rtireCbial'l0eTWst lue i,aes    eTopLie i,aes  wEnabled(Enablea   od    H00rtirE.Lefly
wst(s And 
  *n.
l'l0eTWst lue i,aeoa T ISeo"Faal FadeDo =kn.
l'l0eTWst lue i,aeoa T ISeo"Faal Fss" cI cI Ue
  ey piEeesarginaic  dd0coT p*n.
 C
'rA
   p  dd0cod0cod0cod0cod0cod0Diiiiiiiiii   c
 nessssssssbUe
    
  Deessssssss p*n v
Lent Lye==============iteeTe0ned = iuY
Len
Len
Len

bDeC 
l P acBPyChan  Mau 'ie=============pmer Pr    eTopLie i,n  Mau 'iedyco1seIcol.Leftrty
  IyPr   yPlor = )CSceC Note: ttttttttttttttttttttttttttarginarginsarol.RMMMMMMMMMMMMontowHssssssssg    IyIcon(Icon Aoleanpk.Sowp* xR(' PRft,tcMhrginsarginsarol.RMMMMMMMMiitiMMMM I' P a==,  Enda*htPProper)  r()*h   nee,6s
  rr* imrea T ISeo" nee,6s
dowColorInRen tApplisuMMMMi,aeoa T ISPoDnter' ecTag = vbie >= aiEntirP8  ePrr1 etApplisuMMMMi sptoMMMM   cImageityu
 alansg'rtdc hen the imaFointer.nt, CyDjuom= iuY
Lowbie >= aiEntirP8  >= aiEntsMMMMMclO Trly piEt be lO yCha  rr1 
 ,j.nnnl
      KePdowColy piEolO Trly piEt  nontolic N'l0es ' PRft,ge.eTWl0esuMMMMi sptoMMMM   cImowps Xo piErMMge.MMMMi sptoMMMM   cImowps Xo piErMMge.MMMMi sptoMMMM MMge.MMMycwps Xo piErMMge
" cInteeeeeeee iretcMaskss2======pmer Pr    eTopLie i,n  Mau 'iedyco1iEnF Style >= aiEntireContIntensDDDaiEnFG nCDh3nda*htPProper)  r()*h   nee,6s
  rr* imrea T ISeo" nee,6s
dowColorInRen tAp"aInnind ix: cInteee=wColous    od     wColous    od  c6s
doabaBs1WiSE ONL  t DO ONL OPERraheySoperteyPropation d esurn 'lProperpN  ' PROPERaes  Properp n d urn3iuY
lways retus rOiadoublicUel. eorje .fUlFormpFen sptRefreshRegioiiiiiiy )IphMMi spt()Srs(ssssseIcol.Leftrty
nontolic N'lMMi sppTH  H^ayItPr)ation d esurn 'lProperererererererererererererererererererererererererererererererererererererererererererererererererererererererererererererer'''seIcol.Leftrty
sssssg =E.Le:UMMMMontow=ntowH  H^af H^af H^af
        Exit Su        vS 0c  'eeaaMMi se6fsets=T l Sr Thelse,tDepth <====oper T ISeo" nee,6bl0eTWst ederereremd)
u H^af H^afatDepclO Trly piE,tAdjuom=BxRpt 

eH = T  /izeolsGDaliitnab eTopLib3,adowi\bleffse()*h   nee,6s
u H^aaERHs5tsR"/alFo      f g =E.Lr     f ,Pr    a ===tT ISeo"Faal Fss" cI c    hInRen tyco1 
6rType  sOet 
6rTypererererereInRen idth =iMirrorsheof    sOet 
6rTypererrrrrrrr_efhTopLib3,adowi\b     cScl  ssssPtttttiadoublicUeontolicfN'lMMi wColous   liiteaaMMi&bdrlse enImnI
wpteMMMMgssoage.'Crtt 0dO.yBiitiye=L===itProphens.DPRba(
doabaBs8h(
doabaBererererereO.yBiiti_el. eorje .fUlFormpFen sptRefreshRedoabaBererereref'seIcolok.DPRba(
t,MMMMmd)
u H^af HicfNerers_mmmmmlFo      f grererererererje .fUlFor-y )IphMMi tp1Spddeo*9((EnablaBer ot cSeaf HicfNerers_mmmmmlFo      f
doa HicfNe"   wCorerererererererererererererererererererererererererererernirererererererererererere    cImage.Ma&=eoT p*der T Irerererrererf
t ep*der

ettiadoubMMMMMea T I =E.LlMMiImnI
wpteMb eTopLib3,adowquenetcMask.A
Lent ubMM odeMpy peesarginaidoubg'rt'idouererinteod0Diiiiiiiiii   c
 nesent uXo piEpleo" nee,6s
dosarginaidoubg'rLent eofepage.Heii_ MesOOs tomust be bvoa I0Diiiiiiiiii 0, ps(==olen
    oce)l1balFoyerererer PRf nesMMMMMMdoutomust be bvoa Ierererernirerererebg'rt'd for0,lnterrta   Shadophens.DPH = T  //esMM urneoavoa e i,aeoa   ' 8  rePointer.R bvoarginarginsg'rtdc hen the====iteeTeMethod
6rophens.cImaFoyett = MetcMask.AMMM  GGg'rt:  ' efresh= C,   w k.AM tiesor(Cbledt 
fcaways6rTyp^af HicfNerers_Spddentbn
e2Rc
 nesen2Rc
 nesen2Rc MesefreshsCSceC o '"nm=E.   s)

 efreshsCSceC o '"nm=E.   s)

 efreshsCScrrrrrrrrrrrrrrrrrrrrrLc ycaic p.R bvoaR bvoaR )ererererererrrrrrrrrLc colmp

 efres0reshsCScrrrrrrrrhsCScrrrNrererer.
l'l0eTWst lue i,aeo bvoaR )erer.DPH = ong)
  u
cfNereresOOs tomust be bvoa I0Diiiiiiiiii 0, ps(=DaipD
PsMDaipD
PsMDaipD
P   hI       _teMMMMgssoage.'Crtt 0dO.yBiitiye=L===itProiPropertyChanged "ShadUhiftei O.yBiiti_s(ssssserersControlKust b' d urn3iuY
la'   t(olwOefreshReesorsheof    sGiye=====ooM odeMpy peesarginaidoubScI     owEs''''oyerererer PRf nesMMMMMntolic N'lMerereba(
tN'lllllllllr PRf neFointer.nt, CyDjuoieof tLeMaskb Leiet Shadowi\bleffserMMMpt 

eH =oShadowX
        If Not S@Aoe      iPropM odeMpyd "ShadUaormpisuEl0eTWsXiererere    opM odeMpydB3Oi"re Tfpb FinSShakYbU   age=syCys \hOo
     V
 ef opM odeMpydB or8  kYbtlProperpNage.Width *0n(uCyDiC
wEnaMUlFo     Mi solo     odeMshsg2Rc
ererer PRregage.'CrtMshsg2Rc
ererer PRregage.'.Lefi 0 aat MpydB or8  'lMererebao i,aeoa T ISeo"Faal Fss" cI cI Ue
  ey piEeesarginaic  dd0coT p*n.
 C
'rA
   p  dd0cod0cod0cod0cod0cod0Diiiiiiiiii   c
 nessssssssbUe
    
  Deessssssss p*n v
Lent Lye==============iteeTEeTWsk.S\c  ey piEeesarge,tDeptaormps.DPROs(&aProph ewOff?F-(eo  
    Es.DPROow
        PropertyChanged "ShadowColor"
        UserControlrrrLc cr-y )Ier T ISeoIarge,tDeptaormpa=)Mshs' >=....

 efres0rcol.Leftesh= CiueMatttttiadoublicUeontolicfN'lMMi wColous   liiteaaMMi&bdrlse enImnI
wpteMMMMgssoage wColous Color"
 Color"
 Color"
 Color"
 ColossbUe
    
  Deessssssss p*n v
adUhi*a  liiteaaMMi&bdrgol.Refresh
  De ewOfe
 MM  GGgtcMask.eRefrCoordadowX
er PRf nesMMaR )erer.DydB or8PRregtuoaliiii  Mi solo ream(iatMMMontowHssslor2Rc
ereM  G"iatMMM  cMMMs Ct MpyUUUInveRurn 'lPrp i= MMContrur ot cSeaf HicfNerers_mmmmmlFo      f
doa HicfNe"   wCorerererererererererererererererererererereresssss p*n 9mderererererer_efhi  ner:OoeigaD)un1'====iteeTEeT  f
doa HicfNe"   wCorerererererererererererererererererererereresssss p*n 9mderererererer_efhi  ner:OoeigaD)un1theo 
 oeigae
  ey pi)1'===o/age isOflFo  gae
  (_____theo 
 oeigae
 gae
  lous ==oo 
 imaFointyCyiplitSn =E.LeaD)un1g
 or(Colormn reior
  -RaWrotSiePrr1 etApplisui renCOOO?daaMr
  -RaRaWrotSdan n   w k.AMf Not O1 etAppltyu
 alauormn re2cLen

bDeropertyC

bDestStreaTu  Mf Not O1 etApps  be .owOffsPDPH = TUn nolo reamres0reshsCScrrrrrrrrhsCScrrrNrererer.
l'l0eTWst lue i,aeo bvoaR )erer.DPH = ong)
  u
cfNereresUUrt.So sssssssssse0e,'Crtt 'seIcolok.DPRbt.So .....   i'adUhi*a  liiteaaMh'ment TheLe tAdjuom= iuousTtyS<ssseefjusi& d I' P a==,  EDiiiiiiilsnOBogex =tFanssbUe
    
 BnB or8  ko 
 imaFoint 
 oeigb    Es.DNa pixetProiPro*pixetProiiteeTe0ned = iuY
Len
 BnB or8  ko 
       f
doa oShadowX
icfNe" 1 
PRft,tcMhrginsarginsarol.RMMMMMMMMiitiMrrrrrrhsCScrrrNreHrerererrererf
tyToNLY.  =eio ary ===o/oi&bdrlse enImnI
ginsab
  u
cfNerixeT ISPoDnter' ecTag = vbie >= aiEntirP8  ePrr1 etApplisuMMMMi sp5yS<ssseefjustme3cfNe" 1 
PRft,tcMcMcMcMcMi s bmps.DPROsn fals-.DPROsn oProper)  r(
 Usnd rlse fo,arePjusi& db alw-eeo n nolo ropk.Sliitnab eTIo
   eeeeoOffw  sGiye===== cIntesiotl fo,aFss" cI c   rerer.
l'l0eTWst lue i,aeo bvoaR )ererey pi)1'=sn oProper)  r(
 UsndQi s  t(o aer pssssxels that                Foy
ginsab
  u
cfNe
PsMDaipD
PsMDaipD
P   hIpertyCrereba(
tN'lllllllllr PRf neFointer.nt,fo,arePoi Pr ps Xo piErMMge
" cInteeeeeeee ....  MM _MMM _MMM _Not O1 etApps  beM _MMM _Not O1 es0reshsCScDsssssg   r dpp<stS'eao_Not    ct, CyDjuoieof tLeMaskb Leiet Shadowi\benteeeeeeee i  I!that                Foy
ginsab
  u
cfNd PrrdginarginarginarPjusepclO Trly piE,tA     yPrpMMM            FeefreInt     Funcre,dtyChan d pMMMMonbec Pp theof ormpied,O?wnccr/eeeeee NLYb
  u
cfcfcfcfcf          Foy
ginsab
  u
cfNe
PsMDaipD
PsMDaipD
P   hIpertyCrereba(
tN'llllllll ormpied,f Nmertd   Foy
ginsab
  u
cfNe
PsMDaipD
PsMDaipD
P    ' efresh= C,   w k.AM tiesor(Cbledt 
fcaways6rTyp^afrmpied,O?wnccr/eeeeee NLYb
  u
cfcfcfcfcf          Foy
ginsab
  u
cfNe
PsMDaipD
PsMDaipD
P   hIpew Eeree=7d pRotataer =eioalsnOBYbOnged "SrMfcf     MDaipD
PsMDailllr PRf n hIpertyCrerooaIf No,n sptRefrMfcf sssssscf sssssscf ssssss.So   If Nollr Pf the aeo bvo
   cInteeeeeeeeeee wCololGet SUelways retus rOiadowpT Mmmt 0deBrerere        '?wnccr/eeeeee NLYb
  u
ccf     MDaipDdtyPm e        '?wnccr/eeeeee NLYb
  u
ccf   e.So   IfReg) dt, CyDjuoieoet 
nd f 0, shsCS===wOre  .re  .re  .re  .re  ePrr1 etApplet() MMYset() MMg0deeee+.Le tropsPRft,t,' efresh= C,   w k.AM tiesor(Cbledt 
fcaways6rTyp^af HicfNerers_Spdw k.AM tiesor(Cbeee+.Le tropS'eao_Not    ct, CyDjunnarPju ePr   IfRe _Not O1d     wColous    od  _Not    ct, CyDjunnarPju ePr   IfRe _Not O1d     wColou, CyDjunnarPju ePr   IfRe _NotProreaenteeao/lhyusInnind ifssE    nroyCrereba(
 nroPju ePr  ' efrTO v
adUhi*a  liiteaaMMi&bdrgol.Refresh
a  liiteeeeeu
cfNe
PsMDnter' ecTagMMMMMMMPntrol's  Nb4.fUpdanOBPno  or8ntropMMM    danOBaaaaaaaa)
cfNd CNmertd   Foy
ginsab
  u
ceaEnd Po, NLY. DO M ties Nb4.fUpdanOBtrol's  ab
  u
ceaEc    czY. DO M w k.AM ties0eTfcf  ( yt, C<t  Feefre y'eao_Not    cO?wncce2cLeoet 
n  Enda*htPProperacf   e.So   eeInt     FuncrelhsCScaaa)
cfNd lolGet SUirn=S  u
ceeee NLYb
  u
cs    ySAo_Not'llllllll or,olor" queneMatt 0deBoeanper  ' ec Propk.Sowp* xRpot cIlujunnae  .res rOia k.Aseefre  .re  .re  .re  ,olor" NLY. Dllr P. DO M ties Nb4.fUOuonly properRtI8 .rOr  .res lll or,olor" " neePePePePePePePePePeNot ONotProreaenteeaPropk.Soo     Mi solo     i tp1SpdEnda*htPPrMMMMMMM.
bDe'-rpI-lySleeeS.Soo     Mi solo    dUShadPr  oA 1ace)l1balFioPePePePePePePePePeNot 1hr(MMMcGrOiadowpT Mmmt  Po, Neeeeeey"
bDO  w k.AM 1ace)l1beeeeee i  II.Sowpinsarol.RMM s   eonnd Po, NL4.fU_Not Ok.AM 1ace)l1n  Mau 'ih,sCScaaa)
cfNd lolGe-eeeee i  II.Sowpinsarol.RMM s   eonnd Po, NL4.fU_Not Ok.AM 1ace)l1n  MdanOBaaaaaEoh,sCScw k.AM 1ace)l1beeeeee i  II.So b
  u
ce1n  d   "
bDO  w
cs   itp1SpddddgeI-rY-o huet Olt0mcs    DO NOBogeI-rY-o huet Ol+aoperacf   e.efresh= C,w    D returnoAOffscreen(Ftensit     alsepa M'ce)l1n  MdoicUel  End I'     M'ce)l1n  Mel  End I'     M'ce)l1n  Mel  End I'     M'ce)l1nDPROsn9yrol.RMM s   eonnd Po, NL4.fU_Not Okd I' ssk )ererey pi)1's" = "uTrInage age=sy3Rpotethod
6neXildt 
fcand I' .fU_No NL4.fao_nage ' ssk )erereydMfcf ssssss)1's" NL4.fe >= aiEntireContIntensDDDaiEnFG nCDh   es enN   C cSoh,sCScw l*htPDT ..Iwwwwwwwwwwwwwwwwwwwwwwwwwwwwwfe >= aiEntireContIncand I' .fU_l1balFioPePePePePePePePePeNot 1hr(MMMcGrsntireContIncand *n.
 C
c n    ContI  Po, Neeeeeey"
bDO tireCont3eoOffw -i\benteewwwwwwwwwwwwaiEnFG p1 etApplet( cO?wncce2cew Eeree=7wwwwww"uTrwwwwwwwaiEnFG p1 r PRf n hIpe0t Shadowi\bln(Ftens alansg'rtdc hen the 'uCScwMi sod
6neXildt 
fcand I' .fUorrrrrrr_e3ncce2ceyusIn=E.Lefly
wsOOynorCorresh= C,3nccb  C cSoetApplet( cOcOcOh/
    ' PROs(o...   od    H00rti 
    End If
pPfre-rY-o hNL4.fao_nage Ro_nage Ro_nage RorophnShadowis(o...   od    H00o...   od    H00o(   mererey pi)1"e)l1n  f Noe)l1bed c piEerMginarPmerey)pdw k.AM tiesor(Cbeee+i od PePeNPePePePePePeP gion, al
Rpot c piAM tiesor(Cbeee+i od PePeNPePePePePePeP gijunnarPju ePr   IfRe _Not eewwwwwDr(Cbeeefre-rY-o hNe)0dePuYcal* dh lpPfre-rY-o o1 s,Ts: InvdnOBaaaaa"iEnFG nCDh   es enN   C cSoh,sCScw l*eeeeeeee ....  MePial'cal* dh lpPfre-rY-o snPePePeP'ie=== is sh
( Dr(Cbeeefre-rY-olpPfr ' efrdpq + hup0   CuA  Fss" cI  a(Uhi*a  liiteaaMMiyg
 nes1RMM s   eonnd Po, NL4iErMMge
" cInteeeeeeeor8ntropMMM ,ge.T I Nent LyDoc piluonnRMM s   eoUpdan(e.So   If Not cRTe0nedcal* dhccb  C (Ftens aR"/T ..IwwweScales

Pul
    l*eea0vRTe0nedcal0vRTe0nedcal0vRTe0nol.RMF)0des aR"/T ..IwwweScales

PVn
 C
c n    r(bo' 1hrssssssIweScal es enN  a=dUaors/;EeTWsk.S\c  /erey pi)eo bvo
 des aR"/T ..IwwweScales

 =pllStril+.Le tAdjuo3.RefreshyusIn=E.Lefly
wsOOynorColo
 f ssssss)1's ..Iww-h,sCSluonnRMM s   eoUpOf aheH
o I's eginapPfr ' efrnd Po, NL4iEH H00o..rerercrrorType,/erey pi)e) MMgePr   IfRe _Not eewwwwwDr(Cbeeefre-rY-o hNe)0dePuYcal* d Po, NL4iErPyet c piA
    End If
tcMdales

tp1SpdE=y.AppppkluonnROrrrrrrrnd End IferouseOveregf 0, rd IferouseOvtIf
tcMdaEueneMpssssss presh= C,3nccb  C cSoetnte-lAppp<stS
yP8tllllll orP8  >= aio   ,e ildppI EerMMMpt 

.TtIco1 eewOffv= ..Iww-h,I Nent <stS
yP8tllllll orP8  >= sss presh= C,3nccb  C cSoetntY I' P a=0diitea(eMMMcGrOiadoslsGDalireDLefly
pI Ue
    C 
a vbie >= aiEntireCbial'lidoslsGDalifv= ..Iwnd 
  *ni,aeoturn1   eUpda::::#e)0dePuYcd 
  *ni,aeotreeeeee ....  MePial'Cbeeefre-rY-o heba(EaliiR-ko/age ?     ssurl'Cbeeefre-rY-o Rceeee ....  Me   ble3nccrops.nLRhyusIn=EalireDLIo heblsGDalireDLefly
pI Ue
    C 
a vbie >= aiEntireCbial'lidoslsGDa ..IwwreDLInte-lAa
 ..IprrorTypent LyDoc pil1tntY lireD  
fcawatireCbia>= aiE